var that = this;
function __skpm_run (key, context) {
  that.context = context;

var exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 8);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var persist = __webpack_require__(6);
var LayerType = __webpack_require__(1);

var tranMSColorToRgba = function tranMSColorToRgba(msColor) {
	return {
		r: Math.round(msColor.red() * 255),
		g: Math.round(msColor.green() * 255),
		b: Math.round(msColor.blue() * 255),
		a: Math.round(msColor.alpha() * 100) / 100
	};
};

var tranHexStrToColor = function tranHexStrToColor(hexStr) {
	var c = '';
	if (/^#([A-Fa-f0-9]{3}){1,2}$/.test(hexStr)) {
		c = hexStr.substring(1).split('');
		if (c.length == 3) {
			c = [c[0], c[0], c[1], c[1], c[2], c[2]];
		}
		c = '0x' + c.join('');
		return {
			r: c >> 16 & 255,
			g: c >> 8 & 255,
			b: c & 255,
			a: 1
		};
	}
};

var tranRgbaStrToColor = function tranRgbaStrToColor(rgbaStr) {
	var str = rgbaStr.replace('rgba(', '');
	str = str.replace(')', '');
	var colorArr = str.split(',');
	return {
		r: parseInt(colorArr[0].trim(), 10),
		g: parseInt(colorArr[1].trim(), 10),
		b: parseInt(colorArr[2].trim(), 10),
		a: parseFloat(colorArr[3].trim())
	};
};

// todo 渐变色还需考虑其他属性
var tranGradientToWeb = function tranGradientToWeb(gradient) {
	var colorStops = [];
	var colorStop;
	var colorStopsLoop = gradient.stops().objectEnumerator();
	while (colorStop = colorStopsLoop.nextObject()) {
		colorStops.push(tranMSColorToRgba(colorStop.color()));
	}

	return colorStops;
};

var tranNSStringToStr = function tranNSStringToStr(nsString) {
	var config = arguments.length > 1 ? arguments[1] : null;
	var str = new String(nsString).toString();

	if (config && config.escapeLine) {
		str = str.replace(/\\-/g, '-');
	}

	if (config && config.encode) {
		try {
			str = encodeURIComponent(str);
		} catch (e) {
			log('转换名称失败');
		}
	}
	return str;
};

var tranToWebType = function tranToWebType(msLayer) {
	var layerType = LayerType.Shape;
	if (msLayer['class']() == LayerType.MSTextLayer) {
		layerType = 'text';
	} else if (msLayer['class']() == LayerType.MSLayerGroup || msLayer['class']() == MSLayerGroup.MSArtboardGroup) {
		layerType = 'groupSection';
	} else if (msLayer['class']() == LayerType.MSBitmapLayer) {
		layerType = 'layer';
	} else if (msLayer['class']() == LayerType.MSHotspotLayer) {
		layerType = 'hotspot';
	}
	return layerType;
};

var getAnmitationType = function getAnmitationType(msLayer) {
	var type = msLayer.flow().animationType();
	var typeObj = {
		'-1': 'none',
		'0': 'slideRight',
		'1': 'slideLeft',
		'2': 'slideDown',
		'3': 'slideUp'
	};
	var targetType = typeObj[type] || 'none';
	return targetType;
};

var mapAnmitationTypeToIdoc = function mapAnmitationTypeToIdoc(type) {
	var mapToIdoc = {
		slideFromRight: 'slideRight',
		slideFromLeft: 'slideLeft',
		slideFromBottom: 'slideDown',
		slideFromTop: 'slideUp'
	};
	var targetType = mapToIdoc[type] || 'none';
	return targetType;
};

var isLayerExportable = function isLayerExportable(msLayer) {
	var isExportFormatsAvailable = msLayer.exportOptions().exportFormats().count() > 0;
	//画板被标记为切图不作为切图导出
	if (msLayer['class']() == LayerType.MSArtboardGroup) {
		return false;
	}

	return isExportFormatsAvailable;
};

var isSymbolSlice = function isSymbolSlice(msLayer) {
	if (msLayer['class']() == LayerType.MSSymbolInstance && msLayer.symbolMaster().exportOptions().exportFormats().count() > 0) {
		return true;
	}
	return false;
};

var isLayerRenderable = function isLayerRenderable(msLayer) {
	//只考虑文本、形状、图片、母版实例几种图层 todo 继续研究renderable的含义
	var isRenderable = msLayer['class']() == LayerType.MSTextLayer || msLayer['class']() == LayerType.MSShapeGroup || msLayer['class']() == LayerType.MSBitmapLayer || msLayer['class']() == LayerType.MSSymbolInstance;

	return isRenderable;

	//todo 此处未考虑文本为空，图层被锁定的情况
};

var getRelativeRect = function getRelativeRect(rect, refRect) {
	// 1 过滤掉不在画板区域内的图层
	if (rect.left > refRect.right || rect.right < refRect.left || rect.top > refRect.bottom || rect.bottom < refRect.top) {
		return null;
	}

	rect.left = rect.left - refRect.left;
	rect.top = rect.top - refRect.top;

	if (rect.left + rect.width > refRect.width) {
		rect.width = refRect.width - rect.left;
	}
	if (rect.left < 0) {
		rect.width = rect.width - Math.abs(rect.left);
		rect.left = 0;
	}
	if (rect.top + rect.height > refRect.height) {
		rect.height = refRect.height - rect.top;
	}
	if (rect.top < 0) {
		rect.height = rect.height - Math.abs(rect.top);
		rect.top = 0;
	}

	rect.right = rect.left + rect.width;
	rect.bottom = rect.top + rect.height;
	return rect;
};

var util = {
	tranMSColorToRgba: tranMSColorToRgba,
	tranGradientToWeb: tranGradientToWeb,
	tranNSStringToStr: tranNSStringToStr,
	tranHexStrToColor: tranHexStrToColor,
	tranRgbaStrToColor: tranRgbaStrToColor,

	tranToWebType: tranToWebType,
	getAnmitationType: getAnmitationType,

	isLayerExportable: isLayerExportable,
	isLayerRenderable: isLayerRenderable,
	isSymbolSlice: isSymbolSlice,
	getRelativeRect: getRelativeRect,
	mapAnmitationTypeToIdoc: mapAnmitationTypeToIdoc,
	getRootPropsFromInfo: function () {
		function getRootPropsFromInfo(artboardInfo) {
			return {
				basic: {
					id: artboardInfo.clientID,
					name: artboardInfo.name,
					type: 'groupSection',
					opacity: 1
				},
				bounds: {
					left: 0,
					top: 0,
					width: artboardInfo.size.width,
					height: artboardInfo.size.height
				},
				fill: {
					colors: artboardInfo.backgroundColor ? [artboardInfo.backgroundColor] : undefined
				},
				text: {},
				stroke: {},
				effect: {},
				slice: {}
			};
		}

		return getRootPropsFromInfo;
	}(),

	removeFile: function () {
		function removeFile(path) {
			var url = NSURL.fileURLWithPath(path);
			NSFileManager.defaultManager().removeItemAtURL_error(url, nil);
		}

		return removeFile;
	}(),

	getAppLanguage: function () {
		function getAppLanguage() {
			var language = persist.get('appLanguage');
			if (language == 'null') {
				var str = NSLocale.currentLocale().localeIdentifier() + '';
				var strArr = str.split('_');
				if (strArr.length > 1) {
					language = str.split('_')[1];
				}
			}
			return language;
		}

		return getAppLanguage;
	}(),

	getGradientColor: function () {
		function getGradientColor(gradient) {
			try {
				var colorStop;
				var colorStops = [];
				var gradientTypes = ['linearGradient', 'radialGradient', 'angularGradient'];
				var colorStopsLoop = gradient.stops().objectEnumerator();
				while (colorStop = colorStopsLoop.nextObject()) {
					colorStops.push({
						color: tranMSColorToRgba(colorStop.color()),
						position: colorStop.position()
					});
				}

				return {
					type: gradientTypes[gradient.gradientType()],
					value: {
						fromX: parseFloat(gradient.from().x),
						fromY: parseFloat(gradient.from().y),
						toX: parseFloat(gradient.to().x),
						toY: parseFloat(gradient.to().y),
						colorStops: colorStops
					}
				};
			} catch (e) {}
			return {};
		}

		return getGradientColor;
	}(),

	// 调整一下数据结构
	getNormalColor: function () {
		function getNormalColor(msColor) {
			return Object.assign({
				type: 'normal'
			}, tranMSColorToRgba(msColor));
		}

		return getNormalColor;
	}(),

	emoji: function () {
		function emoji(str) {
			var emojiRegExp = new RegExp('(?:[\u2700-\u27BF]|(?:\uD83C[\uDDE6-\uDDFF]){2}|[\uD800-\uDBFF][\uDC00-\uDFFF]|[#-9]\uFE0F?\u20E3|\u3299|\u3297|\u303D|\u3030|\u24C2|\uD83C[\uDD70-\uDD71]|\uD83C[\uDD7E-\uDD7F]|\uD83C\uDD8E|\uD83C[\uDD91-\uDD9A]|\uD83C[\uDDE6-\uDDFF]|[\uD83C[\uDE01-\uDE02]|\uD83C\uDE1A|\uD83C\uDE2F|[\uD83C[\uDE32-\uDE3A]|[\uD83C[\uDE50-\uDE51]|\u203C|\u2049|[\u25AA-\u25AB]|\u25B6|\u25C0|[\u25FB-\u25FE]|\xA9|\xAE|\u2122|\u2139|\uD83C\uDC04|[\u2600-\u26FF]|\u2B05|\u2B06|\u2B07|\u2B1B|\u2B1C|\u2B50|\u2B55|\u231A|\u231B|\u2328|\u23CF|[\u23E9-\u23F3]|[\u23F8-\u23FA]|\uD83C\uDCCF|\u2934|\u2935|[\u2190-\u21FF])', 'g');
			return str.replace(emojiRegExp, function (match) {
				var u = '';
				for (var i = 0; i < match.length; i++) {
					if (!(i % 2)) {
						u += '&#' + match.codePointAt(i);
					}
				}

				return u;
			});
		}

		return emoji;
	}(),

	uuid: function () {
		function uuid() {
			var s = [];
			var hexDigits = '0123456789abcdef';
			for (var i = 0; i < 36; i++) {
				s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
			}
			s[14] = '4'; // bits 12-15 of the time_hi_and_version field to 0010
			s[19] = hexDigits.substr(s[19] & 0x3 | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
			s[8] = s[13] = s[18] = s[23] = '-';

			var uuid = s.join('');
			return uuid;
		}

		return uuid;
	}(),

	getSelectedArtboardIds: function () {
		function getSelectedArtboardIds(context) {
			var document = context.document;
			var selectedArtboardIds = [];
			try {
				var seletcedLayers = document.selectedLayers().layers();
				if (seletcedLayers.count() > 0) {
					for (var j = 0; j < seletcedLayers.count(); j++) {
						var artboardId = seletcedLayers[j].parentArtboard().objectID();
						selectedArtboardIds.push(util.tranNSStringToStr(artboardId));
					}
				}
			} catch (e) {
				for (var i = 0; i < context.selection.count(); i++) {
					try {
						var artboardId = context.selection[i].parentArtboard().objectID();
						selectedArtboardIds.push(artboardId);
					} catch (e) {}
				}
			}

			return selectedArtboardIds;
		}

		return getSelectedArtboardIds;
	}(),

	getAllArtboardIds: function () {
		function getAllArtboardIds(context) {
			var document = context.document;
			var allArtboardIds = [];
			for (var i = 0; i < document.currentPage().artboards().length; i++) {
				if (document.currentPage().artboards()[i]['class']() == 'MSArtboardGroup') {
					var artboardId = document.currentPage().artboards()[i].objectID();
					allArtboardIds.push(util.tranNSStringToStr(artboardId));
				}
			}
			return allArtboardIds;
		}

		return getAllArtboardIds;
	}(),

	filterPropsId: function () {
		function filterPropsId(layerProps) {
			var newLayers = [];
			for (var i = 0; i < layerProps.length; i++) {
				var layerBasic = Object.assign({}, layerProps[i].basic, {});
				delete layerBasic.id;
				delete layerBasic.parentId;
				newLayers.push(Object.assign({}, layerProps[i], { basic: layerBasic }));
			}
			return newLayers;
		}

		return filterPropsId;
	}(),

	getLayerImage: function () {
		function getLayerImage(document, layer, name, scale) {
			var exportName = NSTemporaryDirectory() + name + '.png';
			var slice = MSExportRequest.exportRequestsFromExportableLayer(layer).firstObject();

			slice.page = document.currentPage();
			slice.format = 'png';
			slice.scale = scale;
			document.saveArtboardOrSlice_toFile(slice, exportName);

			var url = NSURL.fileURLWithPath(exportName);
			var data = NSData.alloc().initWithContentsOfURL(url);
			var base64 = data.base64EncodedStringWithOptions(0);

			NSFileManager.defaultManager().removeItemAtURL_error(url, nil);
			return base64;
		}

		return getLayerImage;
	}(),

	getLayerSvg: function () {
		function getLayerSvg(document, layer, name) {
			var exportName = NSTemporaryDirectory() + name + '.svg';
			var slice = MSExportRequest.exportRequestsFromExportableLayer(layer).firstObject();

			slice.page = document.currentPage();
			slice.format = 'svg';
			document.saveArtboardOrSlice_toFile(slice, exportName);

			var url = NSURL.fileURLWithPath(exportName);
			var data = NSString.alloc().initWithContentsOfURL_encoding_error(url, NSUTF8StringEncoding, nil);

			NSFileManager.defaultManager().removeItemAtURL_error(url, nil);
			return data;
		}

		return getLayerSvg;
	}(),

	getArtboardImage: function () {
		function getArtboardImage(document, msArtboard, scale, page) {
			var path = NSTemporaryDirectory() + msArtboard.objectID() + '.png';
			var request = MSExportRequest.exportRequestsFromExportableLayer(msArtboard).firstObject();
			request.page = page || document.currentPage();
			request.format = 'png';
			request.scale = scale;
			request.includeArtboardBackground = true;
			document.saveArtboardOrSlice_toFile(request, path);

			var url = NSURL.fileURLWithPath(path);
			var data = NSData.alloc().initWithContentsOfURL(url);
			var base64 = data.base64EncodedStringWithOptions(0);

			NSFileManager.defaultManager().removeItemAtURL_error(url, nil);
			return base64;
		}

		return getArtboardImage;
	}(),

	getLayerTree: function () {
		function getLayerTree(layerProps) {
			var layerRoot = null;
			if (layerProps.length > 0) {
				layerRoot = layerProps[0];
				layerRoot.children = findChildren(layerRoot.basic.id, layerProps);
			}
			return layerRoot;
		}

		return getLayerTree;
	}(),

	Timer: {
		startTime: 0,
		endTime: 0,
		start: function () {
			function start() {
				this.startTime = Date.now();
			}

			return start;
		}(),
		end: function () {
			function end() {
				this.endTime = Date.now();
				var total = (this.endTime - this.startTime) / 1000;
				log('excute time: ' + total);
				this.startTime = this.endTime;
			}

			return end;
		}()
	}
};

var findChildren = function findChildren(pId, treeList) {
	var children = treeList.filter(function (layer) {
		return layer.basic.parentId === pId;
	});
	if (children && children.length > 0) {
		children.forEach(function (layer) {
			layer.children = findChildren(layer.basic.id, treeList);
		});
	}
	return children.reverse();
};

module.exports = util;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// 定义使用到的图层的class类型

var Shape = exports.Shape = 'shape';
var MSSymbolMaster = exports.MSSymbolMaster = 'MSSymbolMaster';
var MSArtboardGroup = exports.MSArtboardGroup = 'MSArtboardGroup';
var MSPage = exports.MSPage = 'MSPage';
var MSShapePathLayer = exports.MSShapePathLayer = 'MSShapePathLayer';
var MSShapeGroup = exports.MSShapeGroup = 'MSShapeGroup';
var MSSymbolInstance = exports.MSSymbolInstance = 'MSSymbolInstance';
var MSHotspotLayer = exports.MSHotspotLayer = 'MSHotspotLayer';
var MSBitmapLayer = exports.MSBitmapLayer = 'MSBitmapLayer';
var MSTextLayer = exports.MSTextLayer = 'MSTextLayer';
var MSLayerGroup = exports.MSLayerGroup = 'MSLayerGroup';

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

/* globals coscript, sketch */
var fiberAvailable = __webpack_require__(11)

var setTimeout
var clearTimeout

var fibers = []

if (fiberAvailable()) {
  var fibers = []

  setTimeout = function (func, delay, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10) {
    // fibers takes care of keeping coscript around
    var id = fibers.length
    fibers.push(coscript.scheduleWithInterval_jsFunction(
      (delay || 0) / 1000,
      function () {
        func(param1, param2, param3, param4, param5, param6, param7, param8, param9, param10)
      }
    ))
    return id
  }

  clearTimeout = function (id) {
    var timeout = fibers[id]
    if (timeout) {
      timeout.cancel() // fibers takes care of keeping coscript around
      fibers[id] = undefined // garbage collect the fiber
    }
  }
} else {
  setTimeout = function (func, delay, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10) {
    coscript.shouldKeepAround = true
    var id = fibers.length
    fibers.push(true)
    coscript.scheduleWithInterval_jsFunction(
      (delay || 0) / 1000,
      function () {
        if (fibers[id]) { // if not cleared
          func(param1, param2, param3, param4, param5, param6, param7, param8, param9, param10)
        }
        clearTimeout(id)
        if (fibers.every(function (_id) { return !_id })) { // if everything is cleared
          coscript.shouldKeepAround = false
        }
      }
    )
    return id
  }

  clearTimeout = function (id) {
    fibers[id] = false
  }
}

module.exports = {
  setTimeout: setTimeout,
  clearTimeout: clearTimeout
}


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(console) {/* globals log */

if (true) {
  var sketchUtils = __webpack_require__(13)
  var sketchDebugger = __webpack_require__(15)
  var actions = __webpack_require__(17)

  function getStack() {
    return sketchUtils.prepareStackTrace(new Error().stack)
  }
}

console._skpmPrefix = 'console> '

function logEverywhere(type, args) {
  var values = Array.prototype.slice.call(args)

  // log to the System logs
  values.forEach(function(v) {
    try {
      log(console._skpmPrefix + indentString() + v)
    } catch (e) {
      log(v)
    }
  })

  if (true) {
    if (!sketchDebugger.isDebuggerPresent()) {
      return
    }

    var payload = {
      ts: Date.now(),
      type: type,
      plugin: String(context.scriptPath),
      values: values.map(sketchUtils.prepareValue),
      stack: getStack(),
    }

    sketchDebugger.sendToDebugger(actions.ADD_LOG, payload)
  }
}

var indentLevel = 0
function indentString() {
  var indent = ''
  for (var i = 0; i < indentLevel; i++) {
    indent += '  '
  }
  if (indentLevel > 0) {
    indent += '| '
  }
  return indent
}

var oldGroup = console.group

console.group = function() {
  // log to the JS context
  oldGroup && oldGroup.apply(this, arguments)
  indentLevel += 1
  if (true) {
    sketchDebugger.sendToDebugger(actions.GROUP, {
      plugin: String(context.scriptPath),
      collapsed: false,
    })
  }
}

var oldGroupCollapsed = console.groupCollapsed

console.groupCollapsed = function() {
  // log to the JS context
  oldGroupCollapsed && oldGroupCollapsed.apply(this, arguments)
  indentLevel += 1
  if (true) {
    sketchDebugger.sendToDebugger(actions.GROUP, {
      plugin: String(context.scriptPath),
      collapsed: true
    })
  }
}

var oldGroupEnd = console.groupEnd

console.groupEnd = function() {
  // log to the JS context
  oldGroupEnd && oldGroupEnd.apply(this, arguments)
  indentLevel -= 1
  if (indentLevel < 0) {
    indentLevel = 0
  }
  if (true) {
    sketchDebugger.sendToDebugger(actions.GROUP_END, {
      plugin: context.scriptPath,
    })
  }
}

var counts = {}
var oldCount = console.count

console.count = function(label) {
  label = typeof label !== 'undefined' ? label : 'Global'
  counts[label] = (counts[label] || 0) + 1

  // log to the JS context
  oldCount && oldCount.apply(this, arguments)
  return logEverywhere('log', [label + ': ' + counts[label]])
}

var timers = {}
var oldTime = console.time

console.time = function(label) {
  // log to the JS context
  oldTime && oldTime.apply(this, arguments)

  label = typeof label !== 'undefined' ? label : 'default'
  if (timers[label]) {
    return logEverywhere('warn', ['Timer "' + label + '" already exists'])
  }

  timers[label] = Date.now()
  return
}

var oldTimeEnd = console.timeEnd

console.timeEnd = function(label) {
  // log to the JS context
  oldTimeEnd && oldTimeEnd.apply(this, arguments)

  label = typeof label !== 'undefined' ? label : 'default'
  if (!timers[label]) {
    return logEverywhere('warn', ['Timer "' + label + '" does not exist'])
  }

  var duration = Date.now() - timers[label]
  delete timers[label]
  return logEverywhere('log', [label + ': ' + (duration / 1000) + 'ms'])
}

var oldLog = console.log

console.log = function() {
  // log to the JS context
  oldLog && oldLog.apply(this, arguments)
  return logEverywhere('log', arguments)
}

var oldWarn = console.warn

console.warn = function() {
  // log to the JS context
  oldWarn && oldWarn.apply(this, arguments)
  return logEverywhere('warn', arguments)
}

var oldError = console.error

console.error = function() {
  // log to the JS context
  oldError && oldError.apply(this, arguments)
  return logEverywhere('error', arguments)
}

var oldAssert = console.assert

console.assert = function(condition, text) {
  // log to the JS context
  oldAssert && oldAssert.apply(this, arguments)
  if (!condition) {
    return logEverywhere('assert', [text])
  }
  return undefined
}

var oldInfo = console.info

console.info = function() {
  // log to the JS context
  oldInfo && oldInfo.apply(this, arguments)
  return logEverywhere('info', arguments)
}

var oldClear = console.clear

console.clear = function() {
  oldClear && oldClear()
  if (true) {
    return sketchDebugger.sendToDebugger(actions.CLEAR_LOGS)
  }
}

console._skpmEnabled = true

module.exports = console

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3)))

/***/ }),
/* 4 */
/***/ (function(module, exports) {

/* eslint-disable no-not-accumulator-reassign/no-not-accumulator-reassign, no-var, vars-on-top, prefer-template, prefer-arrow-callback, func-names, prefer-destructuring, object-shorthand */

module.exports = function prepareStackTrace(stackTrace) {
  var stack = stackTrace.split('\n')
  stack = stack.map(function (s) {
    return s.replace(/\sg/, '')
  })

  stack = stack.map(function (entry) {
    // entry is something like `functionName@path/to/my/file:line:column`
    // or `path/to/my/file:line:column`
    // or `path/to/my/file`
    // or `path/to/@my/file:line:column`
    var parts = entry.split('@')
    var fn = parts.shift()
    var filePath = parts.join('@') // the path can contain @

    if (fn.indexOf('/Users/') === 0) {
      // actually we didn't have a fn so just put it back in the filePath
      filePath = fn + (filePath ? ('@' + filePath) : '')
      fn = null
    }

    if (!filePath) {
      // we should always have a filePath, so if we don't have one here, it means that the function what actually anonymous and that it is the filePath instead
      filePath = entry
      fn = null
    }

    var filePathParts = filePath.split(':')
    filePath = filePathParts[0]

    // the file is the last part of the filePath
    var file = filePath.split('/')
    file = file[file.length - 1]

    return {
      fn: fn,
      file: file,
      filePath: filePath,
      line: filePathParts[1],
      column: filePathParts[2],
    }
  })

  return stack
}


/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = function toArray(object) {
  if (Array.isArray(object)) {
    return object
  }
  var arr = []
  for (var j = 0; j < (object || []).length; j += 1) {
    arr.push(object[j])
  }
  return arr
}


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var persist = { // eslint-disable-line no-unused-vars
  get: function () {
    function get(key) {
      return NSUserDefaults.standardUserDefaults().stringForKey(key) + "";
    }

    return get;
  }(),

  set: function () {
    function set(key, value) {
      NSUserDefaults.standardUserDefaults().setObject_forKey(value, key);
      NSUserDefaults.standardUserDefaults().synchronize();
    }

    return set;
  }(),

  remove: function () {
    function remove(key) {
      NSUserDefaults.standardUserDefaults().removeObjectForKey(key);
      NSUserDefaults.standardUserDefaults().synchronize();
    }

    return remove;
  }()
};

module.exports = persist;

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var util = __webpack_require__(0);
var LayerType = __webpack_require__(1);

var propsExporter = {
	init: function () {
		function init(msArtboard) {
			this.layerStateCache = {};
			// 获取传入画板的绝对位置信息
			// this.artRect = this.getAbsoluteRect(msArtboard);
		}

		return init;
	}(),

	getArtboardBackColor: function () {
		function getArtboardBackColor(msArtboard) {
			if (msArtboard.hasBackgroundColor()) {
				return util.getNormalColor(msArtboard.backgroundColor());
			}
		}

		return getArtboardBackColor;
	}(),

	getAbsoluteRect: function () {
		function getAbsoluteRect(msLayer) {
			var msRect = msLayer.absoluteRect();

			var left = msRect.x();
			var top = msRect.y();
			var width = msRect.width();
			var height = msRect.height();
			return {
				left: left,
				top: top,
				width: width,
				height: height,
				right: left + width,
				bottom: top + height
			};
		}

		return getAbsoluteRect;
	}(),

	getInheritState: function () {
		function getInheritState(msLayer, maskObjectID) {
			var isVisible = true;
			var isLocked = false;
			var isMasked = false;
			var hasSlice = false;

			var layerTemp = msLayer;
			while (layerTemp['class']() != LayerType.MSArtboardGroup && layerTemp['class']() != LayerType.MSSymbolMaster) {
				var cacheState = this.layerStateCache[layerTemp.objectID()];
				if (cacheState) {
					if (!cacheState.isVisible) {
						isVisible = false;
					}
					if (cacheState.isLocked) {
						isLocked = true;
					}
					if (cacheState.isMasked) {
						isMasked = true;
					}
					if (cacheState.hasSlice) {
						hasSlice = true;
					}
					break;
				} else {
					var group = layerTemp.parentGroup();
					if (!layerTemp.isVisible()) {
						isVisible = false;
					}
					if (layerTemp.isLocked()) {
						isLocked = true;
					}
					if (maskObjectID && group.objectID() == maskObjectID && !layerTemp.shouldBreakMaskChain()) {
						isMasked = true;
					}
					if (util.isLayerExportable(layerTemp)) {
						hasSlice = true;
					}
					layerTemp = group;
				}
			}

			var inheritState = {
				isVisible: isVisible,
				isLocked: isLocked,
				isMasked: isMasked,
				hasSlice: hasSlice
			};
			this.layerStateCache[msLayer.objectID()] = inheritState;
			return inheritState;
		}

		return getInheritState;
	}(),

	getLayerBasic: function () {
		function getLayerBasic(msLayer, msGroup, propsRecord) {
			var name = msLayer.name() + '';
			name = util.tranNSStringToStr(util.emoji(name));
			var index = name.indexOf('&#');
			if (index !== -1) {
				name = name.substring(0, index);
			}

			var layerTemp = msLayer;
			var parentId;
			while (layerTemp['class']() != LayerType.MSArtboardGroup && layerTemp['class']() != LayerType.MSSymbolMaster) {
				var group = layerTemp.parentGroup();
				var groupId = util.tranNSStringToStr(group.objectID());
				if (propsRecord[groupId]) {
					parentId = propsRecord[groupId].basic.id;
					break;
				}
				layerTemp = group;
			}

			return {
				id: util.tranNSStringToStr(msLayer.objectID()),
				parentId: parentId,
				name: name,
				type: util.tranToWebType(msLayer),
				opacity: 1,
				fillOpacity: 1,
				zIndex: null
			};
		}

		return getLayerBasic;
	}(),

	// 获取一个图层相对于画板的相对位置信息
	getLayerRect: function () {
		function getLayerRect(msLayer, maskRect, inheritState, msArtboard) {
			var layerRect = {};
			var artRect = this.getAbsoluteRect(msArtboard);
			try {
				// 获取图层的绝对位置信息
				layerRect = this.getAbsoluteRect(msLayer);
				// 获取图层相对于画板的坐标信息
				var layerRect = util.getRelativeRect(layerRect, artRect);
				var cutOutArea = function () {
					function cutOutArea(limitRect) {
						// 过滤点不在mask范围内的图层
						if (layerRect.left > limitRect.right) {
							layerRect = null;
							return;
						}
						if (layerRect.top > limitRect.bottom) {
							layerRect = null;
							return;
						}
						if (layerRect.bottom < limitRect.top) {
							layerRect = null;
							return;
						}
						if (layerRect.right < limitRect.left) {
							layerRect = null;
							return;
						}

						if (layerRect.right > limitRect.right) {
							layerRect.right = limitRect.right;
						}
						if (layerRect.bottom > limitRect.bottom) {
							layerRect.bottom = limitRect.bottom;
						}
						if (layerRect.top < limitRect.top) {
							layerRect.top = limitRect.top;
						}
						if (layerRect.left < limitRect.left) {
							layerRect.left = limitRect.left;
						}

						if (layerRect) {
							layerRect.width = layerRect.right - layerRect.left;
							layerRect.height = layerRect.bottom - layerRect.top;
							// 添加阴影数据(在有mask的情况下获取阴影数据会报错，这里捕获一下，不要影响别的图层的解析)
							try {
								var influenceRect = msLayer.absoluteInfluenceRect();
								if (influenceRect) {
									left = influenceRect.origin.x - artRect.left;
									top = influenceRect.origin.y - artRect.top;
									width = influenceRect.size.width;
									height = influenceRect.size.height;
									layerRect.effectLeft = left;
									layerRect.effectTop = top;
									layerRect.effectWidth = width;
									layerRect.effectHeight = height;
								}
							} catch (e) {
								log('获取图层阴影位置数据失败!');
								log(JSON.stringify(e));
							}
						}
					}

					return cutOutArea;
				}();

				// 如果存在mask蒙版，则需要特殊处理一下，只获取mask下的图层信息
				if (inheritState && inheritState.isMasked && maskRect) {
					cutOutArea(maskRect);
				}
				return layerRect;
			} catch (e) {
				log('获取图层矩形区域失败');
			}
			return null;
		}

		return getLayerRect;
	}(),

	getLayerText: function () {
		function getLayerText(msLayer) {
			var styles = [];
			try {
				if (msLayer['class']() == LayerType.MSTextLayer) {
					var attr;
					var textAligns = ['left', 'right', 'center', 'justify', 'left'];

					var getTextColor = function () {
						function getTextColor(attr) {
							if (attr.MSAttributedStringColorAttribute) {
								var value = attr.MSAttributedStringColorAttribute.value;
								// todo 此处需要考虑防御意外情况
								if (value.indexOf('rgba(') > -1) {
									return util.tranRgbaStrToColor(value);
								} else {
									return util.tranHexStrToColor(value);
								}
							}
						}

						return getTextColor;
					}();

					var getTextLineHeight = function () {
						function getTextLineHeight(attr) {
							if (attr.NSParagraphStyle && attr.NSParagraphStyle.style.maximumLineHeight && attr.NSParagraphStyle.style.maximumLineHeight != 0) {
								return attr.NSParagraphStyle.style.maximumLineHeight;
							} else {
								return msLayer.lineHeight() || msLayer.font().defaultLineHeightForFont();
							}
						}

						return getTextLineHeight;
					}();

					var getTextFontFamily = function () {
						function getTextFontFamily(attr) {
							if (attr.NSFont && attr.NSFont.attributes && attr.NSFont.attributes.NSFontNameAttribute) {
								return attr.NSFont.attributes.NSFontNameAttribute;
							} else {
								return attr.NSFont.family;
							}
						}

						return getTextFontFamily;
					}();

					var getTextLetterSpace = function () {
						function getTextLetterSpace(attr) {
							if (attr.NSKern) {
								return Math.round(attr.NSKern * 100) / 100;
							} else {
								return 0;
							}
						}

						return getTextLetterSpace;
					}();

					var getTextFontSize = function () {
						function getTextFontSize(attr) {
							if (attr.NSFont && attr.NSFont.attributes && attr.NSFont.attributes.NSFontSizeAttribute) {
								return attr.NSFont.attributes.NSFontSizeAttribute;
							} else {
								return msLayer.fontSize();
							}
						}

						return getTextFontSize;
					}();

					var getTextAlign = function () {
						function getTextAlign(attr) {
							return textAligns[attr.NSParagraphStyle.style.alignment];
						}

						return getTextAlign;
					}();

					var getTextContent = function () {
						function getTextContent(attr) {
							var str = attr.objectForKey('text');
							var emojiStr = util.emoji(str);
							var content = emojiStr.replace(/\s+/g, ' ');
							return content;
						}

						return getTextContent;
					}();

					var getTextParagraph = function () {
						function getTextParagraph(attr) {
							if (attr && attr.NSParagraphStyle && attr.NSParagraphStyle.style && attr.NSParagraphStyle.style.paragraphSpacingBefore) {
								return attr.NSParagraphStyle.style.paragraphSpacing;
							} else {
								return null;
							}
						}

						return getTextParagraph;
					}();

					var tree = msLayer.attributedStringValue().treeAsDictionary();
					if (tree.attributes) {
						var attributes = tree.attributes.objectEnumerator();

						while (attr = attributes.nextObject()) {
							var colorValue = getTextColor(attr);

							var fontStr = util.tranNSStringToStr(getTextFontFamily(attr));
							var fontArr = fontStr.split('-');
							styles.push({
								value: util.tranNSStringToStr(getTextContent(attr)),
								font: {
									family: fontArr && fontArr[0] || '',
									weight: fontArr && fontArr[1] || '',
									size: util.tranNSStringToStr(getTextFontSize(attr)),
									color: {
										type: 'normal',
										value: colorValue
									}
								},
								space: {
									lineHeight: util.tranNSStringToStr(getTextLineHeight(attr)),
									letterSpacing: util.tranNSStringToStr(getTextLetterSpace(attr)),
									paragraph: util.tranNSStringToStr(getTextParagraph(attr))
								},
								// 暂时没有，默认值设置为null
								fontStyle: {
									underline: null,
									lineThrough: null,
									bold: null,
									italic: null
								},
								align: util.tranNSStringToStr(getTextAlign(attr))
							});
						}
					}
				}
			} catch (e) {
				log('获取文本失败');
			}
			return styles;
		}

		return getLayerText;
	}(),

	getLayerRadius: function () {
		function getLayerRadius(msLayer) {
			try {
				var points = null;
				if (msLayer.layers && msLayer.layers().firstObject() && msLayer.layers().firstObject().fixedRadius) {
					var layers = msLayer.layers();
					points = layers.firstObject().points();
				} else if (msLayer.fixedRadius) {
					points = msLayer.points();
				}
				if (points) {
					if (points && points.length == 4) {
						var radius = [];
						var isInvalid = true;
						for (var i = 0; i < points.length; i++) {
							var r = points.objectAtIndex(i).cornerRadius();
							if (r != 0) {
								isInvalid = false;
							}
							radius.push(r);
						}
						if (isInvalid) {
							return null;
						} else {
							return radius;
						}
					}
				}
			} catch (e) {
				log('获取圆角失败 ' + msLayer.name() + ' ' + msLayer['class']());
			}

			return null;
		}

		return getLayerRadius;
	}(),

	getLayerBorders: function () {
		function getLayerBorders(layerStyle) {
			var layerBorders = [];
			try {
				var border;
				var borderPositions = ['inside', 'center', 'outside'];

				if (layerStyle.borders) {
					var layerBordersLoop = layerStyle.borders().objectEnumerator();

					while (border = layerBordersLoop.nextObject()) {
						if (border.isEnabled()) {
							var color = {};
							if (border.fillType() == 0) {
								color = util.getNormalColor(border.color());
							} else if (border.fillType() == 1) {
								color = util.getGradientColor(border.gradient());
							}

							layerBorders.push({
								type: borderPositions[border.position()],
								strokeWidth: border.thickness(),
								color: color
							});
						}
					}
				}
			} catch (e) {
				log('获取边框失败');
			}

			return layerBorders;
		}

		return getLayerBorders;
	}(),

	getborderOptions: function () {
		function getborderOptions(layerStyle) {
			var dashPattern = [];
			try {
				var dash;

				if (layerStyle.borderOptions) {
					var loop = layerStyle.borderOptions().dashPattern().objectEnumerator();
					while (dash = loop.nextObject()) {
						dashPattern.push(util.tranNSStringToStr(dash));
					}
				}
			} catch (e) {
				log('获取边框线型失败');
			}

			return dashPattern;
		}

		return getborderOptions;
	}(),

	getLayerFills: function () {
		function getLayerFills(layerStyle) {
			var layerFills = [];
			try {
				if (layerStyle.fills) {
					var fill;
					var layerFillsLoop = layerStyle.fills().objectEnumerator();

					while (fill = layerFillsLoop.nextObject()) {
						if (fill.isEnabled()) {
							if (fill.fillType() == 0) {
								layerFills.push(util.getNormalColor(fill.color()));
							} else if (fill.fillType() == 1) {
								layerFills.push(util.getGradientColor(fill.gradient()));
							}
						}
					}
				}
			} catch (e) {
				log('获取填充色失败');
			}
			return layerFills;
		}

		return getLayerFills;
	}(),

	getLayerBlur: function () {
		function getLayerBlur(layerStyle) {
			try {
				var blurObj = {};
				var blurType = ['gaussian', 'motion', 'zoom'];

				if (layerStyle.blur) {
					var blur = layerStyle.blur();
					if (blur && blur.isEnabled()) {
						blurObj = {
							type: blurType[blur.type()],
							radius: Math.round(blur.radius())
						};
						return blurObj;
					}
				}
			} catch (e) {
				log('获取模糊属性失败');
			}

			return null;
		}

		return getLayerBlur;
	}(),

	//获取图层上的阴影效果
	getLayerShadow: function () {
		function getLayerShadow(layerStyle) {
			var layerShadow = [];
			try {
				var shadow;
				if (layerStyle.shadows) {
					var layerShadowLoop = layerStyle.shadows().objectEnumerator();
					while (shadow = layerShadowLoop.nextObject()) {
						if (shadow.isEnabled()) {
							layerShadow.push({
								type: shadow instanceof MSStyleShadow ? 'outside' : 'inside',
								offsetX: shadow.offsetX(),
								offsetY: shadow.offsetY(),
								blur: shadow.blurRadius(),
								spread: shadow.spread(),
								color: util.getNormalColor(shadow.color())
							});
						}
					}
				}

				if (layerStyle.innerShadows) {
					var layerInnerShadowLoop = layerStyle.innerShadows().objectEnumerator();
					while (shadow = layerInnerShadowLoop.nextObject()) {
						if (shadow.isEnabled()) {
							layerShadow.push({
								type: shadow instanceof MSStyleShadow ? 'outside' : 'inside',
								offsetX: shadow.offsetX(),
								offsetY: shadow.offsetY(),
								blur: shadow.blurRadius(),
								spread: shadow.spread(),
								color: util.getNormalColor(shadow.color())
							});
						}
					}
				}
			} catch (e) {
				log('获取阴影失败');
			}

			return layerShadow;
		}

		return getLayerShadow;
	}()
};

module.exports = propsExporter;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

exports['default'] = function (context) {
	var params = {
		// 是否取消上傳
		cancelUpload: false
	};
	return function () {
		webUI.render(context, function (windowObject, action, payload) {
			var sendActionToWeb = function () {
				function sendActionToWeb(action) {
					coscript.scheduleWithRepeatingInterval_jsFunction(0, function (interval) {
						var script = 'triggerWebAction(' + JSON.stringify(action) + ')';
						windowObject.evaluateWebScript(script);
						interval.cancel();
					});
				}

				return sendActionToWeb;
			}();

			var uploadSliceToOss = function () {
				function uploadSliceToOss(fileData, extName, artboardIndex, sliceIndex) {
					sendActionToWeb({
						func: 'uploadFileToOss',
						data: { fileData: fileData, extName: extName, artboardIndex: artboardIndex, sliceIndex: sliceIndex, type: 'slice' }
					});
				}

				return uploadSliceToOss;
			}();

			var uploadPageToOss = function () {
				function uploadPageToOss(fileData, extName, artboardIndex) {
					sendActionToWeb({
						func: 'uploadFileToOss',
						data: { fileData: fileData, extName: extName, artboardIndex: artboardIndex, type: 'page' }
					});
				}

				return uploadPageToOss;
			}();

			var updateProgress = function () {
				function updateProgress(progress) {
					sendActionToWeb({
						func: 'updateProgress',
						data: progress
					});
				}

				return updateProgress;
			}();

			var showSyncMessage = function () {
				function showSyncMessage(progress) {
					sendActionToWeb({
						func: 'showSyncMessage'
					});
				}

				return showSyncMessage;
			}();

			var uploadAll = function () {
				function uploadAll() {
					// 上传时需要筛选出需要上传的画板
					exporter.uploadAllData = exporter.getNeedUploadArtboard();
					// changeDataFormat(exporter.uploadAllData);
					// log('data: 开始准备json数据上传' + JSON.stringify(exporter.uploadAllData));
					sendActionToWeb({
						func: exporter.func,
						data: exporter.uploadAllData
					});
				}

				return uploadAll;
			}();

			// 取消上传
			var handleCancelUpload = function () {
				function handleCancelUpload() {
					sendActionToWeb({
						func: 'handleCancelUpload'
					});
				}

				return handleCancelUpload;
			}();

			var webActionHandler = {
				// 取消上传
				cancelUpload: function () {
					function cancelUpload() {
						params.cancelUpload = true;
					}

					return cancelUpload;
				}(),

				uploadFileToOssOver: function () {
					function uploadFileToOssOver() {
						var artboardIndex = payload.artboardIndex;
						var extName = payload.extName;
						var url = payload.url;
						var type = payload.type;
						// 上传成功回调，判断是否取消上传，如果是取消上传操作，则直接返回即可
						if (params.cancelUpload) {
							handleCancelUpload();
							return;
						}
						// 是否是上传全部页面
						if (type === 'slice') {
							var sliceIndex = payload.sliceIndex;
							exporter.generateSlice(artboardIndex, sliceIndex, extName, url, function () {
								// 切片上传完成，下面进行画板的上传
								try {
									exporter.parsePage(uploadPageToOss, updateProgress, showSyncMessage, handleCancelUpload, params);
								} catch (e) {
									sendActionToWeb({ func: 'exportTerminal', data: 'home.parsePageFail' });
									return;
								}
							});
						} else if (type === 'page') {
							exporter.generatePage(artboardIndex, extName, url, function () {
								// 画板上传完成，准备将准备好的数据json上传到idoc后台
								updateProgress({
									message: 'export.uploading',
									progress: 90
								});
								uploadAll();
							});
						}
					}

					return uploadFileToOssOver;
				}(),

				// 解析画板
				doExportArtboard: function () {
					function doExportArtboard() {
						// 设置需要上传的画板ids
						exporter.artboardIds = payload.artboardIds;
						exporter.func = payload.uploadFunc;
						// 重置params
						params.cancelUpload = false;
						var sliceList = exporter.getSliceList();
						// 25%的进度 正在到处图片（也就是切片）
						if (sliceList.length > 0) {
							try {
								exporter.parseSlice(sliceList, uploadSliceToOss, updateProgress, handleCancelUpload, params);
							} catch (e) {
								sendActionToWeb({ func: 'exportTerminal', data: 'home.parseSliceFail' });
								return;
							}
						} else {
							log('no slice,go page');
							try {
								// 30%的进度
								updateProgress({
									message: 'export.dateUploading',
									progress: 30
								});
								exporter.parsePage(uploadPageToOss, updateProgress, showSyncMessage, handleCancelUpload, params);
							} catch (e) {
								sendActionToWeb({ func: 'exportTerminal', data: 'home.parsePageFail' });
								return;
							}
						}
					}

					return doExportArtboard;
				}(),

				// 解析page
				doExportPage: function () {
					function doExportPage() {
						log('back to export page');
						exporter.artboardIds = payload.artboardIds;
						exporter.func = payload.uploadFunc;
						// 重置params
						params.cancelUpload = false;
						var sliceList = exporter.getSliceList();
						// 25%的进度 正在到处图片（也就是切片）
						if (sliceList.length > 0) {
							try {
								exporter.parseSlice(sliceList, uploadSliceToOss, updateProgress, handleCancelUpload, params);
							} catch (e) {
								sendActionToWeb({ func: 'exportTerminal', data: 'home.parseSliceFail' });
								return;
							}
						} else {
							log('no slice,go page');
							try {
								// 30%的进度
								updateProgress({
									message: 'export.dateUploading',
									progress: 30
								});
								exporter.parsePage(uploadPageToOss, updateProgress, showSyncMessage, handleCancelUpload, params);
							} catch (e) {
								sendActionToWeb({ func: 'exportTerminal', data: 'home.parsePageFail' });
								return;
							}
						}
					}

					return doExportPage;
				}(),

				// 预先解析画板的数据结构（目的是为了检查是否需要更新）
				prepareUploadArtboard: function () {
					function prepareUploadArtboard() {
						var i18nKey;
						var uploadArtboardIds = [];

						if (payload.isSelect) {
							uploadArtboardIds = util.getSelectedArtboardIds(context);
							i18nKey = 'home.noSelectPage';
						} else {
							uploadArtboardIds = util.getAllArtboardIds(context);
							i18nKey = 'home.noOnePage';
						}

						if (uploadArtboardIds.length == 0) {
							sendActionToWeb({ func: 'exportTerminal', data: i18nKey });
							return;
						}

						if (uploadArtboardIds.length == 1) {
							// 上传状态图！
							this.prepareUploadState(uploadArtboardIds);
							return;
						}

						var scale = payload.sliceScale || 1;
						exporter.init(context.document, {
							sliceScale: 4 / scale,
							artboardScale: payload.artboardScale,
							device: payload.device
						});
						try {
							exporter.parseArtboardsWithPage(context.document.currentPage(), uploadArtboardIds, updateProgress, function () {
								// log('export: ' + JSON.stringify(exporter));
								var checkData = exporter.getArtBoardClientIDAndClientHash();
								sendActionToWeb({
									func: 'checkNeedUpload',
									data: checkData
								});
							});
						} catch (e) {
							sendActionToWeb({ func: 'exportTerminal', data: 'home.exportFail' });
							log('Sketch error: ' + JSON.stringify(e));
							return;
						}
					}

					return prepareUploadArtboard;
				}(),

				// 预先解析状态图对应画板的数据结构（目的是为了检查是否需要更新）
				prepareUploadState: function () {
					function prepareUploadState(selectedArtboardIds) {
						var scale = payload.sliceScale || 1;

						exporter.init(context.document, {
							sliceScale: 4 / scale,
							artboardScale: payload.artboardScale,
							device: payload.device
						});
						try {
							exporter.parseArtboardsWithPage(context.document.currentPage(), selectedArtboardIds, updateProgress, function () {
								var checkData = exporter.getArtBoardClientIDAndClientHash();
								sendActionToWeb({
									func: 'checkState',
									data: { clientId: util.tranNSStringToStr(selectedArtboardIds[0]), checkData: checkData }
								});
							});
						} catch (e) {
							sendActionToWeb({ func: 'exportTerminal', data: 'home.exportFail' });
							log('Sketch error: ' + JSON.stringify(e));
							return;
						}
					}

					return prepareUploadState;
				}(),

				// 预先解析pages的数据结构（目的是为了检查是否需要更新）
				prepareUploadPages: function () {
					function prepareUploadPages() {
						var scale = payload.sliceScale || 1;

						exporter.init(context.document, {
							sliceScale: 4 / scale,
							artboardScale: payload.artboardScale,
							device: payload.device
						});
						try {
							exporter.parsePages(updateProgress, function (err, data) {
								var checkData = exporter.getArtBoardClientIDAndClientHash();
								if (exporter.artboardInfos.length === 0) {
									sendActionToWeb({ func: 'exportTerminal', data: 'home.noOnePage' });
								} else {
									sendActionToWeb({
										func: 'checkNeedUploadPage',
										data: checkData
									});
								}
							});
						} catch (e) {
							sendActionToWeb({ func: 'exportTerminal', data: 'home.exportFail' });
							log('Sketch error: ' + JSON.stringify(e));
						}
					}

					return prepareUploadPages;
				}(),

				checkLocalData: function () {
					function checkLocalData() {
						var localData = {
							userInfo: {
								cachedIsLogin: persist.get('isLogin'),
								domain: persist.get('domain') === 'null' ? '' : persist.get('domain'),
								cachedAccount: persist.get('account') === 'null' ? '' : persist.get('account'),
								cachedPassword: persist.get('password') === 'null' ? '' : persist.get('password'),
								cachedRemember: persist.get('remember'),
								cachedToken: persist.get('token')
							},

							language: util.getAppLanguage(),
							uploadStateType: persist.get('uploadStateType') === 'null' ? 'cover' : persist.get('uploadStateType'),
							autoDetection: persist.get('autoDetection') === 'null' ? '' : persist.get('autoDetection'),
							syncAppList: persist.get('syncAppList') === 'null' ? '[]' : persist.get('syncAppList'),
							uploadType: persist.get('uploadType') === 'null' ? '' : persist.get('uploadType'),
							designSize: {
								sizeVal: persist.get('sizeVal') === 'null' ? 'ios1x' : persist.get('sizeVal'),
								sliceScale: persist.get('sliceScale') === 'null' ? 1 : persist.get('sliceScale'),
								artboardScale: persist.get('artboardScale') === 'null' ? 2 : persist.get('artboardScale')
							},

							project: {
								localSelTeamId: persist.get('teamId'),
								localSelProjectId: persist.get('projectId')
							}
						};
						sendActionToWeb({
							func: 'initLocalData',
							data: localData
						});
					}

					return checkLocalData;
				}(),

				cacheData: function () {
					function cacheData() {
						for (var key in payload) {
							if (payload.hasOwnProperty(key)) {
								persist.set(key, payload[key]);
							}
						}
					}

					return cacheData;
				}(),

				printWebLoc: function () {
					function printWebLoc() {
						log('Sketch error: ' + payload);
					}

					return printWebLoc;
				}(),

				openUrl: function () {
					function openUrl() {
						NSWorkspace.sharedWorkspace().openURL(NSURL.URLWithString(payload));
					}

					return openUrl;
				}()
			};

			if (action && typeof webActionHandler[action] === 'function') {
				coscript.scheduleWithRepeatingInterval_jsFunction(0, function (interval) {
					webActionHandler[action]();
					interval.cancel();
				});
			}
		});
	}();
};

var exporter = __webpack_require__(9);

var util = __webpack_require__(0);

var webUI = __webpack_require__(23);

var persist = __webpack_require__(6);

var coscript = COScript.currentCOScript();

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Promise) {

var util = __webpack_require__(0);

var layerExporter = __webpack_require__(18);
var propsExporter = __webpack_require__(7);

var _require = __webpack_require__(20),
    PLUGIN_VERSION = _require.PLUGIN_VERSION,
    DOCUMENT_VERSION = _require.DOCUMENT_VERSION;

var _require2 = __webpack_require__(21),
    SKETCH = _require2.SKETCH,
    DESIGN_SIZE = _require2.DESIGN_SIZE;

var LayerType = __webpack_require__(1);
var md5 = __webpack_require__(22);
var coscript = COScript.currentCOScript();

var uploadSliceCount = 0;
var uploadPageCount = 0;

// msArtboard.class() == ''; 不能用全等(===)，因为这两个不一样,如果要用全等，需要特殊处理一下
var exporter = {
	sliceScale: 1,
	artboardScale: 1,
	designSize: DESIGN_SIZE,
	maxSize: 10000,
	canCheck: true,
	// 画板上传过程中占据的进度条比率
	artBoardPercent: 60,
	// 切片上传过程中占据的进度条比率
	slicePercent: 30,
	// 这是上传全部画板时，需要提交到idoc后台的数据集（即画板数据集，且包括上传为状态图的情况）
	artboardInfos: [],
	// 这是上传全部page时，需要提交到idoc后台的数据集
	pageInfos: [],
	// 这是解析过程中，记录了每个画板的原始画板对象数组（目的是当二次访问时（即解析画板图片时），方便访问到对应的画板对象）
	msArtboards: [],
	// 这时每个画板的所有图层数据，是一个树状结构的数据结构
	recordDatas: [],
	// 真正需要解析的画板clientID数组（因为存在一个检查更新的过程）,null表示需要全部上传
	artboardIds: null,
	// 需要解析的所有画板的图层总数
	totalLayerNum: 0,
	// 用于计数的图层变量
	layerNum: 0,
	// 用于积累: 当图层解析了这么多个maxStep个数时才通知显示进度，否则会频繁通知修改数据，导致渲染频繁，页面卡顿
	step: 0,
	// 图层积累解析多少个时才进行通知显示当前解析进度
	maxStep: 10,
	// 通知进度条变化的次数
	maxNotifyCount: 100,
	// 当前正在解析的pages
	init: function () {
		function init(documnet, options) {
			this.document = documnet;
			this.sliceScale = options.sliceScale || 1;
			this.artboardScale = options.artboardScale || 1;
			this.designSize = options.designSize || DESIGN_SIZE;
			uploadSliceCount = 0;
			uploadPageCount = 0;

			this.msArtboards = [];
			this.artboardInfos = [];
			this.recordDatas = [];
			this.pageInfos = [];
			this.needUploadPages = [];
			this.needUploadInfos = [];
			//
			this.artboardIds = null;
		}

		return init;
	}(),

	// 按需获取一个page里面的所有画板对象
	getNeedParseArtboardFromPage: function () {
		function getNeedParseArtboardFromPage(page, artboardIds) {
			var msArtboard;
			var loop = page.artboards().objectEnumerator();
			// 存储需要解析的画板对象数组
			var needParseArtboards = [];
			while (msArtboard = loop.nextObject()) {
				// 过滤规则：1必须是画板 2 如是page，则上传所有画板 3 按需上传画板
				if (msArtboard['class']() == LayerType.MSArtboardGroup && (!artboardIds || artboardIds.indexOf(util.tranNSStringToStr(msArtboard.objectID())) !== -1)) {
					needParseArtboards.push(msArtboard);
				}
			}

			return needParseArtboards;
		}

		return getNeedParseArtboardFromPage;
	}(),

	// 重置一个page下画板的图层数
	initLayerCount: function () {
		function initLayerCount(needParseArtboards) {
			var totalCount = 0;
			needParseArtboards.forEach(function (art) {
				totalCount += art.children().count();
			});
			this.totalLayerNum = totalCount;
			this.layerNum = 0;
			this.step = 0;
			this.maxStep = Math.round(totalCount / this.maxNotifyCount) || 1;
		}

		return initLayerCount;
	}(),

	// 当解析所有pages时，重置图层数总数
	initLayerCountWithPages: function () {
		function initLayerCountWithPages(pages) {
			var totalCount = 0;
			var msArtboard = void 0;
			pages.forEach(function (page) {
				var loop = page.artboards().objectEnumerator();
				while (msArtboard = loop.nextObject()) {
					if (msArtboard['class']() == LayerType.MSArtboardGroup) {
						totalCount += msArtboard.children().count();
					}
				}
			});

			this.totalLayerNum = totalCount;
			this.layerNum = 0;
			this.step = 0;
			this.maxStep = Math.round(totalCount / this.maxNotifyCount) || 1;
		}

		return initLayerCountWithPages;
	}(),

	// 上传全部画板或者所选画板时，需要上传带目录结构的
	parseArtboardsWithPage: function () {
		function parseArtboardsWithPage(page, uploadArtboardIds, updateProgress, cb) {
			// 获取需要继续的画板数组
			var needParseArtboards = this.getNeedParseArtboardFromPage(page, uploadArtboardIds);
			// 初始化一个page画板的图层总数
			this.initLayerCount(needParseArtboards);
			// 解析画板
			exporter.parseArtboards(page, needParseArtboards, updateProgress, cb);
			this.pageInfos.push({
				name: util.tranNSStringToStr(page.name()),
				dirID: util.tranNSStringToStr(page.objectID()),
				artboardInfos: exporter.artboardInfos
			});
		}

		return parseArtboardsWithPage;
	}(),

	// 过滤掉symbol文件夹
	filterSymbolPages: function () {
		function filterSymbolPages(pages) {
			var resultPages = [];
			var msArtboard;
			pages.forEach(function (page) {
				var loop = page.artboards().objectEnumerator();
				// 计算symbol的个数
				var symbolNum = 0;
				// 计算总的组件数
				var totalNum = 0;
				while (msArtboard = loop.nextObject()) {
					totalNum++;
					msArtboard['class']() == LayerType.MSSymbolMaster && symbolNum++;
				}
				if (symbolNum !== totalNum) {
					// 说明page里面都是symbol组件，就是symbol文件夹
					resultPages.push(page);
				}
			});
			return resultPages;
		}

		return filterSymbolPages;
	}(),

	parsePages: function () {
		async function parsePages(updateProgress, parsePageCb) {
			var allArtboardInfos = [];
			var pages = this.document.pages();

			// 需要去掉symbol对应的page(不解析symbol对应的page)
			pages = this.filterSymbolPages(pages);
			// 初始化图层总数
			this.initLayerCountWithPages(pages);
			for (var i = 0; i < pages.length; i++) {
				var page = pages[i];
				// 需要等上一个page解析完毕后，才进行下一个解析
				try {
					await this.asyncParsePage(page, updateProgress);
				} catch (e) {
					log('解析page失败');
				}
				allArtboardInfos = allArtboardInfos.concat(exporter.artboardInfos);
				exporter.artboardInfos = [];
			}
			exporter.artboardInfos = allArtboardInfos;
			parsePageCb();
		}

		return parsePages;
	}(),

	// 异步解析单个page
	asyncParsePage: function () {
		async function asyncParsePage(page, updateProgress) {
			var self = this;
			return new Promise(function (res, rej) {
				var needParseArtboards = self.getNeedParseArtboardFromPage(page);
				exporter.parseArtboards(page, needParseArtboards, updateProgress, function () {
					// 每调用一次，说明解析完一个page的画板数据了
					self.pageInfos.push({
						name: util.tranNSStringToStr(page.name()),
						dirID: util.tranNSStringToStr(page.objectID()),
						artboardInfos: exporter.artboardInfos
					});
					res();
				});
			});
		}

		return asyncParsePage;
	}(),

	// 解析出画板的位置信息对象
	getArtboardInfo: function () {
		function getArtboardInfo(msArtboard, _index) {
			// 获取画板的位置宽高信息
			var artboardRect = propsExporter.getAbsoluteRect(msArtboard);
			var artID = util.tranNSStringToStr(msArtboard.objectID());

			return {
				artboardID: artID,
				clientID: artID,
				name: util.tranNSStringToStr(msArtboard.name()),
				_index: _index,
				source: SKETCH,
				pluginVersion: PLUGIN_VERSION,
				documentVersion: DOCUMENT_VERSION,

				sliceScale: this.sliceScale,
				artboardScale: this.artboardScale,
				device: this.designSize,

				size: {
					width: artboardRect.width,
					height: artboardRect.height
				},
				positionX: artboardRect.left,
				positionY: artboardRect.top,

				backgroundColor: propsExporter.getArtboardBackColor(msArtboard),
				flows: []
			};
		}

		return getArtboardInfo;
	}(),

	// 解析page下的画板的数据
	parseArtboards: function () {
		function parseArtboards(page, needParseArtboards, updateProgress, cb) {
			var needParseArtboardsLen = needParseArtboards.length;
			// 初始化长度
			var initArtboardsLen = 0;
			var self = this;
			if (needParseArtboardsLen === 0) {
				// 说明没有一个画板,直接返回
				cb();
				return;
			}
			// 遍历解析每个画板数据
			needParseArtboards.forEach(function (msArtboard, index) {
				(function (cb, msArtboard, updateProgress) {
					// 解析出画板的位置宽高等信息
					var artboardInfo = self.getArtboardInfo(msArtboard, index);
					artboardInfo.page = page;
					// 获取画板相对于坐标原点(0,0)的位置信息(即就是该画板的标准props数据结构)，且它是第一个图层数据，会将x, y坐标重置为(0, 0)
					var rootProps = util.getRootPropsFromInfo(artboardInfo);
					var propsRecord = {};
					propsRecord[rootProps.basic.id] = rootProps;
					// layerProps是画板下所有图层的数据集合，数据结构参考rootProps
					var layerProps = [rootProps];
					var msLayer = void 0;
					var sliceLayers = [];
					// 保存的该画板存在的所有切图的切图对象数组信息（方便上传切图完成后，url的组装）
					var sliceProps = [];
					// 交互热区的存储数组
					var flows = [];
					// 获取画板下的所有图层children信息迭代对象
					var msLayersLoop = msArtboard.children().objectEnumerator();

					// 单个画板内的图层数量
					var _totalLayerNum = msArtboard.children().count();
					// 计数单个画板的图层数-初始化
					var _layerNum = 0;
					layerExporter.init(msArtboard);

					// 异步解析画板的所有图层数据
					coscript.scheduleWithRepeatingInterval_jsFunction(0, function (interval) {
						msLayer = msLayersLoop.nextObject();
						if (msLayer) {
							try {
								layerExporter.parseLayer(msLayer, layerProps, propsRecord, sliceLayers, sliceProps, flows, msArtboard);
							} catch (error) {
								log('解析图层失败!');
							}
							// 解析完一个图层数据
							_layerNum++;
							self.layerNum++;
							self.step++;
							var progress = Math.min(Math.floor(self.layerNum / self.totalLayerNum * 100), 100);
							if (self.step >= self.maxStep) {
								// 通知解析进度(maxStep个步进通知一次)
								updateProgress({
									message: 'home.parsingLayer',
									progress: progress,
									parsingLayer: true
								});
								self.step = 0;
							} else if (self.totalLayerNum - self.layerNum <= self.maxStep) {
								updateProgress({
									message: 'home.parsingLayer',
									progress: progress,
									parsingLayer: true
								});
							}

							if (_layerNum >= _totalLayerNum) {
								// 解析完一个画板的所有图层数据
								self.collectData(self, artboardInfo, msArtboard, layerProps, sliceLayers, sliceProps, flows);
								initArtboardsLen++;
								if (initArtboardsLen >= needParseArtboardsLen) {
									// 解析所有画板完毕
									cb();
								}
							}
						} else {
							interval.cancel();
						}
					});
				})(cb, msArtboard, updateProgress);
			});
		}

		return parseArtboards;
	}(),

	collectData: function () {
		function collectData(self, artboardInfo, msArtboard, layerProps, sliceLayers, sliceProps, flows) {

			// 去掉_index的影响，每次都保持一致
			var checkData = Object.assign({}, artboardInfo, { _index: 0 }, { layers: util.filterPropsId(layerProps) });
			try {
				artboardInfo.clientHash = md5.hex_md5(JSON.stringify(checkData));
			} catch (e) {
				artboardInfo.clientHash = util.uuid();
			}

			var layerRoot = util.getLayerTree(layerProps);
			artboardInfo.flows = flows;
			// 画板添加单独的切图数据
			artboardInfo.slices = sliceProps;
			self.msArtboards.push(msArtboard);
			self.artboardInfos.push(artboardInfo);
			self.recordDatas.push({
				clientID: artboardInfo.clientID,
				layers: layerRoot,
				sliceLayers: sliceLayers,
				sliceProps: sliceProps
			});
		}

		return collectData;
	}(),

	// 按需选出需要上传的画板的切图
	getSliceList: function () {
		function getSliceList() {
			var sliceList = [];
			for (var i = 0; i < this.recordDatas.length; i++) {
				var recordData = this.recordDatas[i];
				if (!this.artboardIds || this.artboardIds.indexOf(recordData.clientID) >= 0) {
					var sliceLayers = recordData.sliceLayers;
					var sliceProps = recordData.sliceProps;
					for (var j = 0; j < sliceLayers.length; j++) {
						sliceList.push({
							layer: sliceLayers[j],
							props: sliceProps[j],
							artboardIndex: i,
							sliceIndex: j
						});
					}
				}
			}
			return sliceList;
		}

		return getSliceList;
	}(),

	parseSlice: function () {
		function parseSlice(sliceList, uploadSliceToOss, updateProgress, handleCancelUpload, params) {
			var shouldClose = false;
			var uploadCount = 0;
			var self = this;
			var len = sliceList.length;
			coscript.scheduleWithRepeatingInterval_jsFunction(0, function (interval) {
				// 直接取消上傳
				if (params.cancelUpload) {
					handleCancelUpload();
					interval.cancel();
					return;
				}
				try {
					var sliceItem = sliceList[uploadCount];
					var msLayer = sliceItem.layer;
					var slice = layerExporter.getLayerSlice(self.document, msLayer, self.sliceScale);
					if (slice.bitmap) {
						uploadSliceCount++;
						uploadSliceToOss(slice.bitmap, 'png', sliceItem.artboardIndex, sliceItem.sliceIndex);
					}
					if (slice.svg) {
						uploadSliceCount++;
						uploadSliceToOss(slice.svg, 'svg', sliceItem.artboardIndex, sliceItem.sliceIndex);
					}
					// 显示上传切片的进度
					updateProgress({
						message: 'export.imageExporting',
						progress: Math.floor(self.slicePercent * (uploadCount / len))
					});
				} catch (e) {
					shouldClose = true;
				}

				uploadCount++;
				if (uploadCount >= len) {
					shouldClose = true;
				}
				if (shouldClose) {
					interval.cancel();
				}
			});
		}

		return parseSlice;
	}(),

	// 作用： 1 解析出画板的png图片并上传 2 获取画板下所有图层的json信息并上传（位置信息和阴影等信息）
	parsePage: function () {
		function parsePage(uploadPageToOss, updateProgress, showSyncMessage, handleCancelUpload, params) {
			var shouldClose = false;
			// 遍历所有画板的index初始化
			var uploadCount = 0;
			// 实际需要上传画板的个数初始化
			var needUpdateCount = 0;
			// 全部的画板个数
			var len = this.artboardInfos.length;
			//实际上传的画板个数
			var needUpdateArtBoardLen;
			var self = this;
			if (!this.artboardIds) {
				// 直接上传全部
				needUpdateArtBoardLen = len;
			} else {
				// 按需上传
				needUpdateArtBoardLen = this.artboardIds.length;
			}
			coscript.scheduleWithRepeatingInterval_jsFunction(0, function (interval) {
				if (params.cancelUpload) {
					handleCancelUpload();
					interval.cancel();
					return;
				}
				try {
					var artboardInfo = self.artboardInfos[uploadCount];
					// 每一个画板信息
					var msArtboard = self.msArtboards[uploadCount];
					var recordData = self.recordDatas[uploadCount];

					// 筛选出需要上传的画板
					if (artboardInfo && (!self.artboardIds || self.artboardIds.indexOf(artboardInfo.clientID) !== -1)) {
						// 给提示
						if (self.canCheck) {
							if (artboardInfo.size.width >= self.maxSize || artboardInfo.size.height >= self.maxSize) {
								showSyncMessage();
								self.canCheck = false;
							}
						}
						var pageBase64 = util.getArtboardImage(self.document, msArtboard, self.artboardScale, artboardInfo.page);

						// 显示上传画板的进度
						needUpdateCount++;
						updateProgress({
							message: 'export.dateUploading',
							progress: Math.floor(self.slicePercent + self.artBoardPercent * (needUpdateCount / needUpdateArtBoardLen))
						});
						// 上传画板图片
						uploadPageToOss(util.tranNSStringToStr(pageBase64), 'png', uploadCount);
						uploadPageCount++;
						var jsonData = {
							layers: recordData.layers,
							version: PLUGIN_VERSION
						};
						// 上传画板的json数据（包含切图的json数据），记录需要上传的画板jsonindex
						uploadPageToOss(jsonData, 'json', uploadCount);
						uploadPageCount++;
					}
				} catch (e) {
					shouldClose = true;
					self.canCheck = true;
				}

				uploadCount++;
				if (uploadCount >= len) {
					shouldClose = true;
					self.canCheck = true;
				}
				if (shouldClose) {
					interval.cancel();
				}
			});
		}

		return parsePage;
	}(),

	// 将url组装到json中
	generateSlice: function () {
		function generateSlice(artboardIndex, sliceIndex, extName, url, generateOver) {
			var recordData = this.recordDatas[artboardIndex];
			var sliceProps = recordData.sliceProps;
			var props = sliceProps[sliceIndex];
			if (extName === 'png') {
				props.slice.bitmapURL = url;
			} else if (extName === 'svg') {
				props.slice.svgURL = url;
			} else {
				return;
			}
			uploadSliceCount--;
			if (uploadSliceCount <= 0) {
				generateOver();
			}
		}

		return generateSlice;
	}(),

	// 作用：当画板图片或者画板的json数据上传阿里云或者服务器成功后，需要拼接上json或者画板图片png的地址到artboardInfo中去
	generatePage: function () {
		function generatePage(artboardIndex, extName, url, generateOver) {
			var artboardInfo = this.artboardInfos[artboardIndex];
			if (!artboardInfo.fileRes) {
				artboardInfo.fileRes = {};
			}
			if (extName === 'png') {
				artboardInfo.fileRes.image = { URL: url };
			} else if (extName === 'json') {
				artboardInfo.fileRes.data = { URL: url };
			} else {
				return;
			}
			uploadPageCount--;
			if (uploadPageCount <= 0) {
				generateOver();
			}
		}

		return generatePage;
	}(),

	// 最后需要筛选所有page中需要上传的画板
	getNeedUploadArtboard: function () {
		function getNeedUploadArtboard() {
			var _this = this;

			// 1 获取将要上传的画板对象
			var pageInfos = this.pageInfos;
			if (this.artboardIds) {
				pageInfos.forEach(function (page) {
					// 筛选出需要上传的画板
					var newArtboards = page.artboardInfos.filter(function (artboard) {
						return _this.artboardIds.indexOf(artboard.clientID) >= 0;
					});
					// 调整画板顺序
					newArtboards.sort(function (a, b) {
						return b._index - a._index;
					});
					page.artboardInfos = newArtboards;
				});
			}
			// 2 slices数据转换
			this.handleSlicesToArtboards(pageInfos);
			return pageInfos;
		}

		return getNeedUploadArtboard;
	}(),

	// 转化slices为标准数据结构
	handleSlicesToArtboards: function () {
		function handleSlicesToArtboards(pageInfos) {
			var _this2 = this;

			pageInfos.forEach(function (page) {
				page.artboardInfos.forEach(function (artboard) {
					artboard.slices = _this2.changeDataToStandardSlice(artboard);
				});
			});
		}

		return handleSlicesToArtboards;
	}(),

	// 将artbord中的切图数据转换为后台需要的数据结构
	changeDataToStandardSlice: function () {
		function changeDataToStandardSlice(artboard) {
			var newSlices = [];
			if (!artboard) {
				return newSlices;
			}
			newSlices = artboard.slices.map(function (slice) {
				return {
					name: slice.basic.name,
					bitmapURL: slice.slice.bitmapURL,
					svgURL: slice.slice.svgURL,
					size: {
						width: slice.bounds.width,
						height: slice.bounds.height
					}
				};
			});
			return newSlices;
		}

		return changeDataToStandardSlice;
	}(),

	// 获取page的所有画板的clientID和clientHash
	getArtBoardClientIDAndClientHash: function () {
		function getArtBoardClientIDAndClientHash() {
			var artboards = [];
			this.pageInfos.forEach(function (page) {
				// 筛选出clientID、clientHash
				page.artboardInfos.forEach(function (_ref) {
					var clientID = _ref.clientID,
					    clientHash = _ref.clientHash;
					return artboards.push({ clientID: clientID, clientHash: clientHash });
				});
			});
			return artboards;
		}

		return getArtBoardClientIDAndClientHash;
	}()
};

module.exports = exporter;
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(10)))

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(setTimeout, setImmediate, console) {

// Store setTimeout reference so promise-polyfill will be unaffected by
// other code modifying setTimeout (like sinon.useFakeTimers())
var setTimeoutFunc = setTimeout;

function noop() {}

// Polyfill for Function.prototype.bind
function bind(fn, thisArg) {
  return function() {
    fn.apply(thisArg, arguments);
  };
}

function Promise(fn) {
  if (!(this instanceof Promise))
    throw new TypeError('Promises must be constructed via new');
  if (typeof fn !== 'function') throw new TypeError('not a function');
  this._state = 0;
  this._handled = false;
  this._value = undefined;
  this._deferreds = [];

  doResolve(fn, this);
}

function handle(self, deferred) {
  while (self._state === 3) {
    self = self._value;
  }
  if (self._state === 0) {
    self._deferreds.push(deferred);
    return;
  }
  self._handled = true;
  Promise._immediateFn(function() {
    var cb = self._state === 1 ? deferred.onFulfilled : deferred.onRejected;
    if (cb === null) {
      (self._state === 1 ? resolve : reject)(deferred.promise, self._value);
      return;
    }
    var ret;
    try {
      ret = cb(self._value);
    } catch (e) {
      reject(deferred.promise, e);
      return;
    }
    resolve(deferred.promise, ret);
  });
}

function resolve(self, newValue) {
  try {
    // Promise Resolution Procedure: https://github.com/promises-aplus/promises-spec#the-promise-resolution-procedure
    if (newValue === self)
      throw new TypeError('A promise cannot be resolved with itself.');
    if (
      newValue &&
      (typeof newValue === 'object' || typeof newValue === 'function')
    ) {
      var then = newValue.then;
      if (newValue instanceof Promise) {
        self._state = 3;
        self._value = newValue;
        finale(self);
        return;
      } else if (typeof then === 'function') {
        doResolve(bind(then, newValue), self);
        return;
      }
    }
    self._state = 1;
    self._value = newValue;
    finale(self);
  } catch (e) {
    reject(self, e);
  }
}

function reject(self, newValue) {
  self._state = 2;
  self._value = newValue;
  finale(self);
}

function finale(self) {
  if (self._state === 2 && self._deferreds.length === 0) {
    Promise._immediateFn(function() {
      if (!self._handled) {
        Promise._unhandledRejectionFn(self._value);
      }
    });
  }

  for (var i = 0, len = self._deferreds.length; i < len; i++) {
    handle(self, self._deferreds[i]);
  }
  self._deferreds = null;
}

function Handler(onFulfilled, onRejected, promise) {
  this.onFulfilled = typeof onFulfilled === 'function' ? onFulfilled : null;
  this.onRejected = typeof onRejected === 'function' ? onRejected : null;
  this.promise = promise;
}

/**
 * Take a potentially misbehaving resolver function and make sure
 * onFulfilled and onRejected are only called once.
 *
 * Makes no guarantees about asynchrony.
 */
function doResolve(fn, self) {
  var done = false;
  try {
    fn(
      function(value) {
        if (done) return;
        done = true;
        resolve(self, value);
      },
      function(reason) {
        if (done) return;
        done = true;
        reject(self, reason);
      }
    );
  } catch (ex) {
    if (done) return;
    done = true;
    reject(self, ex);
  }
}

Promise.prototype['catch'] = function(onRejected) {
  return this.then(null, onRejected);
};

Promise.prototype.then = function(onFulfilled, onRejected) {
  var prom = new this.constructor(noop);

  handle(this, new Handler(onFulfilled, onRejected, prom));
  return prom;
};

Promise.prototype['finally'] = function(callback) {
  var constructor = this.constructor;
  return this.then(
    function(value) {
      return constructor.resolve(callback()).then(function() {
        return value;
      });
    },
    function(reason) {
      return constructor.resolve(callback()).then(function() {
        return constructor.reject(reason);
      });
    }
  );
};

Promise.all = function(arr) {
  return new Promise(function(resolve, reject) {
    if (!arr || typeof arr.length === 'undefined')
      throw new TypeError('Promise.all accepts an array');
    var args = Array.prototype.slice.call(arr);
    if (args.length === 0) return resolve([]);
    var remaining = args.length;

    function res(i, val) {
      try {
        if (val && (typeof val === 'object' || typeof val === 'function')) {
          var then = val.then;
          if (typeof then === 'function') {
            then.call(
              val,
              function(val) {
                res(i, val);
              },
              reject
            );
            return;
          }
        }
        args[i] = val;
        if (--remaining === 0) {
          resolve(args);
        }
      } catch (ex) {
        reject(ex);
      }
    }

    for (var i = 0; i < args.length; i++) {
      res(i, args[i]);
    }
  });
};

Promise.resolve = function(value) {
  if (value && typeof value === 'object' && value.constructor === Promise) {
    return value;
  }

  return new Promise(function(resolve) {
    resolve(value);
  });
};

Promise.reject = function(value) {
  return new Promise(function(resolve, reject) {
    reject(value);
  });
};

Promise.race = function(values) {
  return new Promise(function(resolve, reject) {
    for (var i = 0, len = values.length; i < len; i++) {
      values[i].then(resolve, reject);
    }
  });
};

// Use polyfill for setImmediate for performance gains
Promise._immediateFn =
  (typeof setImmediate === 'function' &&
    function(fn) {
      setImmediate(fn);
    }) ||
  function(fn) {
    setTimeoutFunc(fn, 0);
  };

Promise._unhandledRejectionFn = function _unhandledRejectionFn(err) {
  if (typeof console !== 'undefined' && console) {
    console.warn('Possible Unhandled Promise Rejection:', err); // eslint-disable-line no-console
  }
};

module.exports = Promise;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2)["setTimeout"], __webpack_require__(12)["setImmediate"], __webpack_require__(3)))

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = function () {
  return typeof coscript !== 'undefined' && coscript.createFiber
}


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

/* globals coscript, sketch */
var timeout = __webpack_require__(2)

function setImmediate(func, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10) {
  return timeout.setTimeout(func, 0, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10)
}

function clearImmediate(id) {
  return timeout.clearTimeout(id)
}

module.exports = {
  setImmediate: setImmediate,
  clearImmediate: clearImmediate
}


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

var prepareValue = __webpack_require__(14)

module.exports.toArray = __webpack_require__(5)
module.exports.prepareStackTrace = __webpack_require__(4)
module.exports.prepareValue = prepareValue
module.exports.prepareObject = prepareValue.prepareObject
module.exports.prepareArray = prepareValue.prepareArray


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

/* eslint-disable no-not-accumulator-reassign/no-not-accumulator-reassign, no-var, vars-on-top, prefer-template, prefer-arrow-callback, func-names, prefer-destructuring, object-shorthand */
var prepareStackTrace = __webpack_require__(4)
var toArray = __webpack_require__(5)

function prepareArray(array, options) {
  return array.map(function(i) {
    return prepareValue(i, options)
  })
}

function prepareObject(object, options) {
  const deep = {}
  Object.keys(object).forEach(function(key) {
    deep[key] = prepareValue(object[key], options)
  })
  return deep
}

function getName(x) {
  return {
    type: 'String',
    primitive: 'String',
    value: String(x.name()),
  }
}

function getSelector(x) {
  return {
    type: 'String',
    primitive: 'String',
    value: String(x.selector()),
  }
}

function introspectMochaObject(value, options) {
  options = options || {}
  var mocha = value.class().mocha()
  var introspection = {
    properties: {
      type: 'Array',
      primitive: 'Array',
      value: toArray(
        mocha['properties' + (options.withAncestors ? 'WithAncestors' : '')]()
      ).map(getName),
    },
    classMethods: {
      type: 'Array',
      primitive: 'Array',
      value: toArray(
        mocha['classMethods' + (options.withAncestors ? 'WithAncestors' : '')]()
      ).map(getSelector),
    },
    instanceMethods: {
      type: 'Array',
      primitive: 'Array',
      value: toArray(
        mocha['instanceMethods' + (options.withAncestors ? 'WithAncestors' : '')]()
      ).map(getSelector),
    },
    protocols: {
      type: 'Array',
      primitive: 'Array',
      value: toArray(
        mocha['protocols' + (options.withAncestors ? 'WithAncestors' : '')]()
      ).map(getName),
    },
  }
  if (mocha.treeAsDictionary && options.withTree) {
    introspection.treeAsDictionary = {
      type: 'Object',
      primitive: 'Object',
      value: prepareObject(mocha.treeAsDictionary())
    }
  }
  return introspection
}

function prepareValue(value, options) {
  var type = 'String'
  var primitive = 'String'
  const typeOf = typeof value
  if (value instanceof Error) {
    type = 'Error'
    primitive = 'Error'
    value = {
      message: value.message,
      name: value.name,
      stack: prepareStackTrace(value.stack),
    }
  } else if (Array.isArray(value)) {
    type = 'Array'
    primitive = 'Array'
    value = prepareArray(value, options)
  } else if (value === null || value === undefined || Number.isNaN(value)) {
    type = 'Empty'
    primitive = 'Empty'
    value = String(value)
  } else if (typeOf === 'object') {
    if (value.isKindOfClass && typeof value.class === 'function') {
      type = String(value.class())
      // TODO: Here could come some meta data saved as value
      if (
        type === 'NSDictionary' ||
        type === '__NSDictionaryM' ||
        type === '__NSSingleEntryDictionaryI' ||
        type === '__NSDictionaryI' ||
        type === '__NSCFDictionary'
      ) {
        primitive = 'Object'
        value = prepareObject(Object(value), options)
      } else if (
        type === 'NSArray' ||
        type === 'NSMutableArray' ||
        type === '__NSArrayM' ||
        type === '__NSSingleObjectArrayI' ||
        type === '__NSArray0'
      ) {
        primitive = 'Array'
        value = prepareArray(toArray(value), options)
      } else if (
        type === 'NSString' ||
        type === '__NSCFString' ||
        type === 'NSTaggedPointerString' ||
        type === '__NSCFConstantString'
      ) {
        primitive = 'String'
        value = String(value)
      } else if (type === '__NSCFNumber' || type === 'NSNumber') {
        primitive = 'Number'
        value = 0 + value
      } else if (type === 'MOStruct') {
        type = String(value.name())
        primitive = 'Object'
        value = value.memberNames().reduce(function(prev, k) {
          prev[k] = prepareValue(value[k], options)
          return prev
        }, {})
      } else if (value.class().mocha) {
        primitive = 'Mocha'
        value = (options || {}).skipMocha ? type : introspectMochaObject(value, options)
      } else {
        primitive = 'Unknown'
        value = type
      }
    } else {
      type = 'Object'
      primitive = 'Object'
      value = prepareObject(value, options)
    }
  } else if (typeOf === 'function') {
    type = 'Function'
    primitive = 'Function'
    value = String(value)
  } else if (value === true || value === false) {
    type = 'Boolean'
    primitive = 'Boolean'
  } else if (typeOf === 'number') {
    primitive = 'Number'
    type = 'Number'
  }

  return {
    value,
    type,
    primitive,
  }
}

module.exports = prepareValue
module.exports.prepareObject = prepareObject
module.exports.prepareArray = prepareArray


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

/* eslint-disable no-not-accumulator-reassign/no-not-accumulator-reassign, no-var, vars-on-top, prefer-template, prefer-arrow-callback, func-names, prefer-destructuring, object-shorthand */
var remoteWebview = __webpack_require__(16)

module.exports.identifier = 'skpm.debugger'

module.exports.isDebuggerPresent = remoteWebview.isWebviewPresent.bind(
  this,
  module.exports.identifier
)

module.exports.sendToDebugger = function sendToDebugger(name, payload) {
  return remoteWebview.sendToWebview(
    module.exports.identifier,
    'sketchBridge(' +
      JSON.stringify({
        name: name,
        payload: payload,
      }) +
      ');'
  )
}


/***/ }),
/* 16 */
/***/ (function(module, exports) {

/* globals NSThread */

var threadDictionary = NSThread.mainThread().threadDictionary()

module.exports.isWebviewPresent = function isWebviewPresent (identifier) {
  return !!threadDictionary[identifier]
}

module.exports.sendToWebview = function sendToWebview (identifier, evalString) {
  if (!module.exports.isWebviewPresent(identifier)) {
    throw new Error('Webview ' + identifier + ' not found')
  }

  var webview = threadDictionary[identifier]
    .contentView()
    .subviews()
  webview = webview[webview.length - 1]

  return webview.stringByEvaluatingJavaScriptFromString(evalString)
}


/***/ }),
/* 17 */
/***/ (function(module, exports) {

module.exports.SET_TREE = 'elements/SET_TREE'
module.exports.SET_PAGE_METADATA = 'elements/SET_PAGE_METADATA'
module.exports.SET_LAYER_METADATA = 'elements/SET_LAYER_METADATA'
module.exports.ADD_LOG = 'logs/ADD_LOG'
module.exports.CLEAR_LOGS = 'logs/CLEAR_LOGS'
module.exports.GROUP = 'logs/GROUP'
module.exports.GROUP_END = 'logs/GROUP_END'
module.exports.TIMER_START = 'logs/TIMER_START'
module.exports.TIMER_END = 'logs/TIMER_END'
module.exports.ADD_REQUEST = 'network/ADD_REQUEST'
module.exports.SET_RESPONSE = 'network/SET_RESPONSE'
module.exports.ADD_ACTION = 'actions/ADD_ACTION'
module.exports.SET_SCRIPT_RESULT = 'playground/SET_SCRIPT_RESULT'


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var util = __webpack_require__(0);

var propsExporter = __webpack_require__(7);
var LayerType = __webpack_require__(1);
var layerExporter = {
	init: function () {
		function init(msArtboard) {
			/* 	this.maskObjectID = null;
   this.maskRect = {}; */

			propsExporter.init(msArtboard);
		}

		return init;
	}(),

	// 解析图层信息（且只解析画板内有效的图层对象）
	parseLayer: function () {
		function parseLayer(msLayer, layerProps, propsRecord, sliceLayers, sliceProps, flows, msArtboard) {
			// 父图层是形状组的图层跳过，不考虑path级别的图层
			// 母版模型跳过
			// todo 后续扩展()
			// MSShapePathLayer
			if (msLayer['class']() == LayerType.MSSymbolMaster || msLayer['class']() == LayerType.MSArtboardGroup || msLayer['class']() == LayerType.MSPage) {
				return;
			}

			var msGroup = msLayer.parentGroup();
			if (msGroup['class']() == LayerType.MSShapeGroup) {
				return;
			}

			var props = this.getLayerProps(msLayer, propsRecord, msArtboard);
			var isSymbolInstance = msLayer['class']() == LayerType.MSSymbolInstance;
			if (props) {
				/* 
     优化：如果图层是symbol类型，那么
     1 如果是在画板上的symbol切图，那么不使用画板的msLayer导出切图，而是使用symbol实例导出切图。
     2 如果即在画板上的symbol切图，又在symbol组件上切图，那么以symbol实例导出切图
     即始终以symbol实例的切图为准
    */
				// 屏蔽掉内部的slice解析
				var isDelaySlice = props.slice.isDelaySlice;
				if (isDelaySlice) {
					if (isSymbolInstance) {
						// 切图在symbol实例上，那么以symbol的实例去生成切图图片, 同時添加到layerProps
						sliceProps.push(props);
						sliceLayers.push(msLayer.symbolMaster());
					} else {
						sliceProps.push(props);
						sliceLayers.push(msLayer);
					}
				} else if (isSymbolInstance) {
					this.parseSymbolInstance(msLayer, props, layerProps, propsRecord, sliceLayers, sliceProps, flows, msArtboard);
				}

				// 解析flow（热区）
				var flowData = this.getFlowData(msLayer, msArtboard);
				if (flowData && flows) {
					flows.push(flowData);
				}

				if (!isSymbolInstance || isSymbolInstance && isDelaySlice) {
					propsRecord[props.basic.id] = props;
					layerProps.push(props);
				}
			}
		}

		return parseLayer;
	}(),

	// 解析symbol内部的图层结构
	parseSymbolInstance: function () {
		function parseSymbolInstance(msLayer, props, layerProps, propsRecord, sliceLayers, sliceProps, flows, msArtboard) {
			var tempSymbol = msLayer.duplicate();
			var temp;
			try {
				temp = tempSymbol.detachByReplacingWithGroup();
				temp.resizeToFitChildrenWithOption(0);
			} catch (e) {
				try {
					temp = tempSymbol.detachStylesAndReplaceWithGroupRecursively(msLayer);
				} catch (e) {
					var parent = tempSymbol.parentGroup();
					if (parent) parent.removeLayer(tempSymbol);
				}
			}

			if (!temp) {
				return [];
			}
			var tempSymbolLayer;
			var tempLoop = temp.children().objectEnumerator();

			// 判断symbol是否被标记为切图(且在画板标记为切图的话，那么还是以symbol切图为准)，是的话需要解析symbol为切图
			if (util.isSymbolSlice(msLayer)) {
				sliceProps.push(props);
				sliceLayers.push(msLayer.symbolMaster());
				props.slice.isDelaySlice = true;
			}
			while (tempSymbolLayer = tempLoop.nextObject()) {
				this.parseLayer(tempSymbolLayer, layerProps, propsRecord, sliceLayers, sliceProps, flows, msArtboard);
			}

			var tempParent = temp.parentGroup();
			if (tempParent) tempParent.removeLayer(temp);
			var parent = tempSymbol.parentGroup();
			if (parent) parent.removeLayer(tempSymbol);
		}

		return parseSymbolInstance;
	}(),

	// 解析传入的图层的信息并返回
	getLayerProps: function () {
		function getLayerProps(msLayer, propsRecord, msArtboard) {
			var msGroup = msLayer.parentGroup();
			var maskObjectID;
			var maskRect;
			if (msLayer.hasClippingMask()) {
				maskObjectID = msGroup.objectID();
				maskRect = bounds;
			} else if (maskObjectID != msGroup.objectID() || msLayer.shouldBreakMaskChain()) {
				maskObjectID = null;
				maskRect = {};
			}

			var inheritState = propsExporter.getInheritState(msLayer, maskObjectID);
			var isExportable = util.isLayerExportable(msLayer);

			if (!inheritState.isVisible || msLayer.isLocked()) {
				return null;
			}

			var props = {};

			// 获取图层的基本信息（名字, id等）
			var basic = propsExporter.getLayerBasic(msLayer, msGroup, propsRecord);

			// 获取图层的位置信息（相对于画板）
			var bounds = propsExporter.getLayerRect(msLayer, maskRect, inheritState, msArtboard);

			if (!basic || !bounds) {
				// 表示这个图层不在画板内或者无效，直接返回
				return null;
			}

			var text = {};
			var stroke = {};
			var fill = {};
			var effect = {};
			var slice = {};

			// 图层描述信息
			var description = null;

			// 是否是分组
			var isGroup = null;

			var styles = propsExporter.getLayerText(msLayer);
			if (styles.length > 0) text.styles = styles;

			var radius = propsExporter.getLayerRadius(msLayer);
			if (radius) stroke.radius = radius;

			if (msLayer.style) {
				var layerStyle = msLayer.style();

				// setting中可以取到opacity和blending两个属性
				basic.opacity = Math.round(layerStyle.contextSettings().opacity() * 100) / 100;

				var borders = propsExporter.getLayerBorders(layerStyle);
				if (borders.length > 0) stroke.borders = borders;

				var dash = propsExporter.getborderOptions(layerStyle);
				if (dash.length > 0) stroke.dash = dash;

				var fillColors = propsExporter.getLayerFills(layerStyle);
				if (fillColors.length > 0) fill.colors = fillColors;

				var shadow = propsExporter.getLayerShadow(layerStyle);
				if (shadow.length > 0) effect.shadows = shadow;

				var blur = propsExporter.getLayerBlur(layerStyle);
				if (blur) effect.blur = blur;
			}

			if (isExportable) {
				slice.isDelaySlice = true;
			}

			props = {
				basic: basic,
				bounds: bounds,
				text: text,
				stroke: stroke,
				fill: fill,
				effect: effect,
				slice: slice,
				description: description,
				isGroup: isGroup
			};

			return props;
		}

		return getLayerProps;
	}(),

	getFlowData: function () {
		function getFlowData(msLayer, msArtboard) {
			try {
				var rect = propsExporter.getLayerRect(msLayer, null, null, msArtboard);

				if (rect && msLayer.flow && msLayer.flow()) {
					var flowData = null;
					if (msLayer['class']() == LayerType.MSHotspotLayer) {
						flowData = {
							targetId: util.tranNSStringToStr(msLayer.flow().destinationArtboardID()),
							animationType: util.getAnmitationType(msLayer)
						};
					} else {
						try {
							var Document = __webpack_require__(19).Document;
							var newApiDocument = Document.getSelectedDocument();
							flowData = newApiDocument.getLayerWithID(msLayer.objectID()).flow.toJSON();
							// 处理一下animationType兼容,否则会报错
							flowData.animationType = util.mapAnmitationTypeToIdoc(flowData.animationType);
						} catch (e) {}
					}

					if (flowData) {
						return {
							left: rect.left,
							top: rect.top,
							width: rect.width,
							height: rect.height,
							flow: flowData
						};
					}
				}
			} catch (e) {
				log('获取交互失败');
			}

			return null;
		}

		return getFlowData;
	}(),

	// 解析切图
	getLayerSlice: function () {
		function getLayerSlice(document, msLayer, sliceScale) {
			var slice = {};
			try {
				var isExportable = util.isLayerExportable(msLayer);
				var name = util.tranNSStringToStr(msLayer.name());
				if (msLayer['class']() != LayerType.MSBitmapLayer) {
					var svgBase64 = util.getLayerSvg(document, msLayer, name);
					slice['svg'] = util.tranNSStringToStr(svgBase64);
				}
				var pngBase64 = util.getLayerImage(document, msLayer, name, sliceScale);
				slice['bitmap'] = util.tranNSStringToStr(pngBase64);
			} catch (e) {
				log('导出切图失败');
			}
			return slice;
		}

		return getLayerSlice;
	}()
};

module.exports = layerExporter;

/***/ }),
/* 19 */
/***/ (function(module, exports) {

module.exports = require("sketch/dom");

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// 插件版本号
var PLUGIN_VERSION = exports.PLUGIN_VERSION = '1.3.0';
// 文档版本号
var DOCUMENT_VERSION = exports.DOCUMENT_VERSION = '2.0';

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var SKETCH = exports.SKETCH = 'sketch';
var DESIGN_SIZE = exports.DESIGN_SIZE = 'ios1x';

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/*
 Javascript MD5 library - version 0.4

 Coded (2011) by Luigi Galli - LG@4e71.org - http://faultylabs.com

 Thanks to: Roberto Viola

 The below code is PUBLIC DOMAIN - NO WARRANTY!

 Changelog: 
            Version 0.4   - 2011-06-19
            + added compact version (md5_compact_min.js), this is a slower but smaller version 
              (more than 4KB lighter before stripping/minification)
            + added preliminary support for Typed Arrays (see: 
              https://developer.mozilla.org/en/JavaScript_typed_arrays and 
              http://www.khronos.org/registry/typedarray/specs/latest/)
              MD5() now accepts input data as ArrayBuffer, Float32Array, Float64Array, 
              Int16Array, Int32Array, Int8Array, Uint16Array, Uint32Array or Uint8Array 
            - moved unit tests to md5_test.js
            - minor refactoring 

            Version 0.3.* - 2011-06-##
            - Internal dev versions

            Version 0.2 - 2011-05-22 
            ** FIXED: serious integer overflow problems which could cause a wrong MD5 hash being returned

            Version 0.1 - 2011
            -Initial version
*/

// if (typeof faultylabs == 'undefined') {
//     faultylabs = {}
// }

/*
   MD5()

    Computes the MD5 hash for the given input data

    input :  data as String - (Assumes Unicode code points are encoded as UTF-8. If you 
                               attempt to digest Unicode strings using other encodings 
                               you will get incorrect results!)

             data as array of characters - (Assumes Unicode code points are encoded as UTF-8. If you 
                              attempt to digest Unicode strings using other encodings 
                              you will get incorrect results!)

             data as array of bytes (plain javascript array of integer numbers)

             data as ArrayBuffer (see: https://developer.mozilla.org/en/JavaScript_typed_arrays)
            
             data as Float32Array, Float64Array, Int16Array, Int32Array, Int8Array, Uint16Array, Uint32Array or Uint8Array (see: https://developer.mozilla.org/en/JavaScript_typed_arrays)
             
             (DataView is not supported yet)

   output: MD5 hash (as Hex Uppercase String)
*/

var hex_md5 = function hex_md5(data) {

    // convert number to (unsigned) 32 bit hex, zero filled string
    function to_zerofilled_hex(n) {
        var t1 = (n >>> 0).toString(16);
        return "00000000".substr(0, 8 - t1.length) + t1;
    }

    // convert array of chars to array of bytes 
    function chars_to_bytes(ac) {
        var retval = [];
        for (var i = 0; i < ac.length; i++) {
            retval = retval.concat(str_to_bytes(ac[i]));
        }
        return retval;
    }

    // convert a 64 bit unsigned number to array of bytes. Little endian
    function int64_to_bytes(num) {
        var retval = [];
        for (var i = 0; i < 8; i++) {
            retval.push(num & 0xFF);
            num = num >>> 8;
        }
        return retval;
    }

    //  32 bit left-rotation
    function rol(num, places) {
        return num << places & 0xFFFFFFFF | num >>> 32 - places;
    }

    // The 4 MD5 functions
    function fF(b, c, d) {
        return b & c | ~b & d;
    }

    function fG(b, c, d) {
        return d & b | ~d & c;
    }

    function fH(b, c, d) {
        return b ^ c ^ d;
    }

    function fI(b, c, d) {
        return c ^ (b | ~d);
    }

    // pick 4 bytes at specified offset. Little-endian is assumed
    function bytes_to_int32(arr, off) {
        return arr[off + 3] << 24 | arr[off + 2] << 16 | arr[off + 1] << 8 | arr[off];
    }

    /*
    Conver string to array of bytes in UTF-8 encoding
    See: 
    http://www.dangrossman.info/2007/05/25/handling-utf-8-in-javascript-php-and-non-utf8-databases/
    http://stackoverflow.com/questions/1240408/reading-bytes-from-a-javascript-string
    How about a String.getBytes(<ENCODING>) for Javascript!? Isn't it time to add it?
    */
    function str_to_bytes(str) {
        var retval = [];
        for (var i = 0; i < str.length; i++) {
            if (str.charCodeAt(i) <= 0x7F) {
                retval.push(str.charCodeAt(i));
            } else {
                var tmp = encodeURIComponent(str.charAt(i)).substr(1).split('%');
                for (var j = 0; j < tmp.length; j++) {
                    retval.push(parseInt(tmp[j], 0x10));
                }
            }
        }return retval;
    }

    // convert the 4 32-bit buffers to a 128 bit hex string. (Little-endian is assumed)
    function int128le_to_hex(a, b, c, d) {
        var ra = "";
        var t = 0;
        var ta = 0;
        for (var i = 3; i >= 0; i--) {
            ta = arguments[i];
            t = ta & 0xFF;
            ta = ta >>> 8;
            t = t << 8;
            t = t | ta & 0xFF;
            ta = ta >>> 8;
            t = t << 8;
            t = t | ta & 0xFF;
            ta = ta >>> 8;
            t = t << 8;
            t = t | ta;
            ra = ra + to_zerofilled_hex(t);
        }
        return ra;
    }

    // conversion from typed byte array to plain javascript array 
    function typed_to_plain(tarr) {
        var retval = new Array(tarr.length);
        for (var i = 0; i < tarr.length; i++) {
            retval[i] = tarr[i];
        }
        return retval;
    }

    // check input data type and perform conversions if needed
    var databytes = null;
    // String
    var type_mismatch = null;
    if (typeof data == 'string') {
        // convert string to array bytes
        databytes = str_to_bytes(data);
    } else if (data.constructor == Array) {
        if (data.length === 0) {
            // if it's empty, just assume array of bytes
            databytes = data;
        } else if (typeof data[0] == 'string') {
            databytes = chars_to_bytes(data);
        } else if (typeof data[0] == 'number') {
            databytes = data;
        } else {
            type_mismatch = _typeof(data[0]);
        }
    } else if (typeof ArrayBuffer != 'undefined') {
        if (data instanceof ArrayBuffer) {
            databytes = typed_to_plain(new Uint8Array(data));
        } else if (data instanceof Uint8Array || data instanceof Int8Array) {
            databytes = typed_to_plain(data);
        } else if (data instanceof Uint32Array || data instanceof Int32Array || data instanceof Uint16Array || data instanceof Int16Array || data instanceof Float32Array || data instanceof Float64Array) {
            databytes = typed_to_plain(new Uint8Array(data.buffer));
        } else {
            type_mismatch = typeof data === "undefined" ? "undefined" : _typeof(data);
        }
    } else {
        type_mismatch = typeof data === "undefined" ? "undefined" : _typeof(data);
    }

    if (type_mismatch) {
        // alert('MD5 type mismatch, cannot process ' + type_mismatch)
    }

    function _add(n1, n2) {
        return 0x0FFFFFFFF & n1 + n2;
    }

    return do_digest();

    function do_digest() {

        // function update partial state for each run
        function updateRun(nf, sin32, dw32, b32) {
            var temp = d;
            d = c;
            c = b;
            //b = b + rol(a + (nf + (sin32 + dw32)), b32)
            b = _add(b, rol(_add(a, _add(nf, _add(sin32, dw32))), b32));
            a = temp;
        }

        // save original length
        var org_len = databytes.length;

        // first append the "1" + 7x "0"
        databytes.push(0x80);

        // determine required amount of padding
        var tail = databytes.length % 64;
        // no room for msg length?
        if (tail > 56) {
            // pad to next 512 bit block
            for (var i = 0; i < 64 - tail; i++) {
                databytes.push(0x0);
            }
            tail = databytes.length % 64;
        }
        for (i = 0; i < 56 - tail; i++) {
            databytes.push(0x0);
        }
        // message length in bits mod 512 should now be 448
        // append 64 bit, little-endian original msg length (in *bits*!)
        databytes = databytes.concat(int64_to_bytes(org_len * 8));

        // initialize 4x32 bit state
        var h0 = 0x67452301;
        var h1 = 0xEFCDAB89;
        var h2 = 0x98BADCFE;
        var h3 = 0x10325476;

        // temp buffers
        var a = 0,
            b = 0,
            c = 0,
            d = 0;

        // Digest message
        for (i = 0; i < databytes.length / 64; i++) {
            // initialize run
            a = h0;
            b = h1;
            c = h2;
            d = h3;

            var ptr = i * 64;

            // do 64 runs
            updateRun(fF(b, c, d), 0xd76aa478, bytes_to_int32(databytes, ptr), 7);
            updateRun(fF(b, c, d), 0xe8c7b756, bytes_to_int32(databytes, ptr + 4), 12);
            updateRun(fF(b, c, d), 0x242070db, bytes_to_int32(databytes, ptr + 8), 17);
            updateRun(fF(b, c, d), 0xc1bdceee, bytes_to_int32(databytes, ptr + 12), 22);
            updateRun(fF(b, c, d), 0xf57c0faf, bytes_to_int32(databytes, ptr + 16), 7);
            updateRun(fF(b, c, d), 0x4787c62a, bytes_to_int32(databytes, ptr + 20), 12);
            updateRun(fF(b, c, d), 0xa8304613, bytes_to_int32(databytes, ptr + 24), 17);
            updateRun(fF(b, c, d), 0xfd469501, bytes_to_int32(databytes, ptr + 28), 22);
            updateRun(fF(b, c, d), 0x698098d8, bytes_to_int32(databytes, ptr + 32), 7);
            updateRun(fF(b, c, d), 0x8b44f7af, bytes_to_int32(databytes, ptr + 36), 12);
            updateRun(fF(b, c, d), 0xffff5bb1, bytes_to_int32(databytes, ptr + 40), 17);
            updateRun(fF(b, c, d), 0x895cd7be, bytes_to_int32(databytes, ptr + 44), 22);
            updateRun(fF(b, c, d), 0x6b901122, bytes_to_int32(databytes, ptr + 48), 7);
            updateRun(fF(b, c, d), 0xfd987193, bytes_to_int32(databytes, ptr + 52), 12);
            updateRun(fF(b, c, d), 0xa679438e, bytes_to_int32(databytes, ptr + 56), 17);
            updateRun(fF(b, c, d), 0x49b40821, bytes_to_int32(databytes, ptr + 60), 22);
            updateRun(fG(b, c, d), 0xf61e2562, bytes_to_int32(databytes, ptr + 4), 5);
            updateRun(fG(b, c, d), 0xc040b340, bytes_to_int32(databytes, ptr + 24), 9);
            updateRun(fG(b, c, d), 0x265e5a51, bytes_to_int32(databytes, ptr + 44), 14);
            updateRun(fG(b, c, d), 0xe9b6c7aa, bytes_to_int32(databytes, ptr), 20);
            updateRun(fG(b, c, d), 0xd62f105d, bytes_to_int32(databytes, ptr + 20), 5);
            updateRun(fG(b, c, d), 0x2441453, bytes_to_int32(databytes, ptr + 40), 9);
            updateRun(fG(b, c, d), 0xd8a1e681, bytes_to_int32(databytes, ptr + 60), 14);
            updateRun(fG(b, c, d), 0xe7d3fbc8, bytes_to_int32(databytes, ptr + 16), 20);
            updateRun(fG(b, c, d), 0x21e1cde6, bytes_to_int32(databytes, ptr + 36), 5);
            updateRun(fG(b, c, d), 0xc33707d6, bytes_to_int32(databytes, ptr + 56), 9);
            updateRun(fG(b, c, d), 0xf4d50d87, bytes_to_int32(databytes, ptr + 12), 14);
            updateRun(fG(b, c, d), 0x455a14ed, bytes_to_int32(databytes, ptr + 32), 20);
            updateRun(fG(b, c, d), 0xa9e3e905, bytes_to_int32(databytes, ptr + 52), 5);
            updateRun(fG(b, c, d), 0xfcefa3f8, bytes_to_int32(databytes, ptr + 8), 9);
            updateRun(fG(b, c, d), 0x676f02d9, bytes_to_int32(databytes, ptr + 28), 14);
            updateRun(fG(b, c, d), 0x8d2a4c8a, bytes_to_int32(databytes, ptr + 48), 20);
            updateRun(fH(b, c, d), 0xfffa3942, bytes_to_int32(databytes, ptr + 20), 4);
            updateRun(fH(b, c, d), 0x8771f681, bytes_to_int32(databytes, ptr + 32), 11);
            updateRun(fH(b, c, d), 0x6d9d6122, bytes_to_int32(databytes, ptr + 44), 16);
            updateRun(fH(b, c, d), 0xfde5380c, bytes_to_int32(databytes, ptr + 56), 23);
            updateRun(fH(b, c, d), 0xa4beea44, bytes_to_int32(databytes, ptr + 4), 4);
            updateRun(fH(b, c, d), 0x4bdecfa9, bytes_to_int32(databytes, ptr + 16), 11);
            updateRun(fH(b, c, d), 0xf6bb4b60, bytes_to_int32(databytes, ptr + 28), 16);
            updateRun(fH(b, c, d), 0xbebfbc70, bytes_to_int32(databytes, ptr + 40), 23);
            updateRun(fH(b, c, d), 0x289b7ec6, bytes_to_int32(databytes, ptr + 52), 4);
            updateRun(fH(b, c, d), 0xeaa127fa, bytes_to_int32(databytes, ptr), 11);
            updateRun(fH(b, c, d), 0xd4ef3085, bytes_to_int32(databytes, ptr + 12), 16);
            updateRun(fH(b, c, d), 0x4881d05, bytes_to_int32(databytes, ptr + 24), 23);
            updateRun(fH(b, c, d), 0xd9d4d039, bytes_to_int32(databytes, ptr + 36), 4);
            updateRun(fH(b, c, d), 0xe6db99e5, bytes_to_int32(databytes, ptr + 48), 11);
            updateRun(fH(b, c, d), 0x1fa27cf8, bytes_to_int32(databytes, ptr + 60), 16);
            updateRun(fH(b, c, d), 0xc4ac5665, bytes_to_int32(databytes, ptr + 8), 23);
            updateRun(fI(b, c, d), 0xf4292244, bytes_to_int32(databytes, ptr), 6);
            updateRun(fI(b, c, d), 0x432aff97, bytes_to_int32(databytes, ptr + 28), 10);
            updateRun(fI(b, c, d), 0xab9423a7, bytes_to_int32(databytes, ptr + 56), 15);
            updateRun(fI(b, c, d), 0xfc93a039, bytes_to_int32(databytes, ptr + 20), 21);
            updateRun(fI(b, c, d), 0x655b59c3, bytes_to_int32(databytes, ptr + 48), 6);
            updateRun(fI(b, c, d), 0x8f0ccc92, bytes_to_int32(databytes, ptr + 12), 10);
            updateRun(fI(b, c, d), 0xffeff47d, bytes_to_int32(databytes, ptr + 40), 15);
            updateRun(fI(b, c, d), 0x85845dd1, bytes_to_int32(databytes, ptr + 4), 21);
            updateRun(fI(b, c, d), 0x6fa87e4f, bytes_to_int32(databytes, ptr + 32), 6);
            updateRun(fI(b, c, d), 0xfe2ce6e0, bytes_to_int32(databytes, ptr + 60), 10);
            updateRun(fI(b, c, d), 0xa3014314, bytes_to_int32(databytes, ptr + 24), 15);
            updateRun(fI(b, c, d), 0x4e0811a1, bytes_to_int32(databytes, ptr + 52), 21);
            updateRun(fI(b, c, d), 0xf7537e82, bytes_to_int32(databytes, ptr + 16), 6);
            updateRun(fI(b, c, d), 0xbd3af235, bytes_to_int32(databytes, ptr + 44), 10);
            updateRun(fI(b, c, d), 0x2ad7d2bb, bytes_to_int32(databytes, ptr + 8), 15);
            updateRun(fI(b, c, d), 0xeb86d391, bytes_to_int32(databytes, ptr + 36), 21);

            // update buffers
            h0 = _add(h0, a);
            h1 = _add(h1, b);
            h2 = _add(h2, c);
            h3 = _add(h3, d);
        }
        // Done! Convert buffers to 128 bit (LE)
        return int128le_to_hex(h3, h2, h1, h0).toUpperCase();
    }
};

var myMd5 = function myMd5(str) {
    var hash = 0,
        i,
        chr;
    var strLen = str.length;
    if (strLen === 0) return hash + '';
    for (i = 0; i < strLen; i++) {
        chr = str.charCodeAt(i);
        hash = (hash << 5) - hash + chr;
        hash |= 0; // Convert to 32bit integer
    }
    return hash + '';
};

var md5 = {
    hex_md5: hex_md5,
    myMd5: myMd5
};

module.exports = md5;

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var MochaJSDelegate = __webpack_require__(24);

var coScript = COScript.currentCOScript();
var closeWebView = function closeWebView() {};
var webUI = {
		identifier: 'com.idoc.sketch',
		threadDictionary: NSThread.mainThread().threadDictionary(),

		render: function () {
				function render(context, callback) {
						var result = false,
						    width = 280,
						    height = 408,
						    _this = this,
						    bgcolor = NSColor.colorWithRed_green_blue_alpha(242 / 255, 242 / 255, 242 / 255, 1),
						    identifier = this.identifier,
						    idocPlugin = this.threadDictionary[identifier];
						if (idocPlugin) {
								return;
						}
						var resourcePath = context.plugin.urlForResourceNamed('html/index.html').path();
						var url = encodeURI('file://' + resourcePath);
						// var url = 'http://localhost:3000';

						coscript.setShouldKeepAround(true);

						var webViewPanel = NSPanel.alloc().init();
						webViewPanel.setTitleVisibility(NSWindowTitleHidden);
						webViewPanel.setTitlebarAppearsTransparent(true);
						// 隐藏panel的最小化及最大化按钮
						/* 		webViewPanel.standardWindowButton(NSWindowCloseButton).setHidden(false);
      		webViewPanel.standardWindowButton(NSWindowMiniaturizeButton).setHidden(true);
      		webViewPanel.standardWindowButton(NSWindowZoomButton).setHidden(true); */
						webViewPanel.setFrame_display(NSMakeRect(0, 0, width, height), false);
						webViewPanel.setBackgroundColor(bgcolor);

						var contentView = webViewPanel.contentView(),
						    webView = WebView.alloc().initWithFrame(NSMakeRect(0, 0, width, height - 32)),
						    delegate = new MochaJSDelegate();

						delegate.setHandlerForSelector('webView:didFinishLoadForFrame:', function (webView, webFrame) {});

						delegate.setHandlerForSelector('webView:didChangeLocationWithinPageForFrame:', function (webView, webFrame) {
								var windowObject = webView.windowScriptObject();
								var str = windowObject.valueForKey('data');
								var response = JSON.parse(str);
								var action = response.action;
								var payload = response.payload;

								callback(windowObject, action, payload);
						});

						contentView.setWantsLayer(true);
						contentView.layer().setFrame(contentView.frame());
						contentView.layer().setCornerRadius(6);
						contentView.layer().setMasksToBounds(true);
						webView.setBackgroundColor(bgcolor);
						webView.setFrameLoadDelegate_(delegate.getClassInstance());

						webView.setMainFrameURL_(url);
						contentView.addSubview(webView);

						var closeButton = webViewPanel.standardWindowButton(NSWindowCloseButton);
						closeButton.setCOSJSTargetFunction(function (sender) {
								closeWebView();
						});
						closeButton.setAction('callAction:');

						webViewPanel.becomeKeyWindow();
						webViewPanel.center();
						webViewPanel.makeKeyAndOrderFront(nil);
						webViewPanel.setLevel(NSFloatingWindowLevel);
						this.threadDictionary[identifier] = webViewPanel;

						closeWebView = function () {
								function closeWebView() {
										_this.shouldClose = true;
										coscript.setShouldKeepAround(false);
										_this.threadDictionary.removeObjectForKey(identifier);
										webViewPanel.close();
								}

								return closeWebView;
						}();
						return result;
				}

				return render;
		}()
};

module.exports = webUI;

/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

//
//  MochaJSDelegate.js
//  MochaJSDelegate
//
//  Created by Matt Curtis
//  Copyright (c) 2015. All rights reserved.
//

var MochaJSDelegate = function MochaJSDelegate(selectorHandlerDict) {
	var uniqueClassName = "MochaJSDelegate_DynamicClass_" + NSUUID.UUID().UUIDString();

	var delegateClassDesc = MOClassDescription.allocateDescriptionForClassWithName_superclass_(uniqueClassName, NSObject);

	delegateClassDesc.registerClass();

	//	Handler storage

	var handlers = {};

	//	Define interface

	this.setHandlerForSelector = function (selectorString, func) {
		var handlerHasBeenSet = selectorString in handlers;
		var selector = NSSelectorFromString(selectorString);

		handlers[selectorString] = func;

		if (!handlerHasBeenSet) {
			/*
   	For some reason, Mocha acts weird about arguments:
   	https://github.com/logancollins/Mocha/issues/28
   		We have to basically create a dynamic handler with a likewise dynamic number of predefined arguments.
   */

			var dynamicHandler = function dynamicHandler() {
				var functionToCall = handlers[selectorString];

				if (!functionToCall) return;

				return functionToCall.apply(delegateClassDesc, arguments);
			};

			var match;
			var args = [],
			    regex = /:/g;
			while (match = regex.exec(selectorString)) {
				args.push("arg" + args.length);
			}var dynamicFunction = eval("(function(" + args.join(",") + "){ return dynamicHandler.apply(this, arguments); })");

			delegateClassDesc.addInstanceMethodWithSelector_function_(selector, dynamicFunction);
		}
	};

	this.removeHandlerForSelector = function (selectorString) {
		delete handlers[selectorString];
	};

	this.getHandlerForSelector = function (selectorString) {
		return handlers[selectorString];
	};

	this.getAllHandlers = function () {
		return handlers;
	};

	this.getClass = function () {
		return NSClassFromString(uniqueClassName);
	};

	this.getClassInstance = function () {
		return NSClassFromString(uniqueClassName)["new"]();
	};

	//	Conveience

	if ((typeof selectorHandlerDict === "undefined" ? "undefined" : _typeof(selectorHandlerDict)) == "object") {
		for (var selectorString in selectorHandlerDict) {
			this.setHandlerForSelector(selectorString, selectorHandlerDict[selectorString]);
		}
	}
};

module.exports = MochaJSDelegate;

/***/ })
/******/ ]);
  if (key === 'default' && typeof exports === 'function') {
    exports(context);
  } else {
    exports[key](context);
  }
}
that['onRun'] = __skpm_run.bind(this, 'default')
